SystemOrganization addCategory: #'XPath-Core'!
SystemOrganization addCategory: 'XPath-Core-DOM'!
SystemOrganization addCategory: 'XPath-Core-Exceptions'!
SystemOrganization addCategory: 'XPath-Core-Functions'!
SystemOrganization addCategory: 'XPath-Core-Parsers'!
SystemOrganization addCategory: 'XPath-Core-Streams'!

!XMLComment methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self string! !

XMLException subclass: #XPathException
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathException commentStamp: 'monty 12/20/2014 19:26' prior: 0!
A base class for XPath exceptions.!

XPathException subclass: #XPathArgumentNumberException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathArgumentNumberException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for function calls with the wrong number of arguments.!

XPathException subclass: #XPathDOMException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathDOMException commentStamp: 'monty 6/11/2015 00:17' prior: 0!
Invoked when node sets are manipulated incorrectly.!

!XPathException methodsFor: 'testing' stamp: 'monty 4/12/2015 07:26'!
hasPosition
	^ position notNil! !

!XPathException methodsFor: 'accessing' stamp: 'monty 4/11/2015 05:37'!
position
	^ position! !

!XPathException methodsFor: 'accessing' stamp: 'monty 4/12/2015 07:26'!
position: aPosition
	position := aPosition.
	self
		append: aPosition
		withDescription: 'at pos.'.! !

XPathException subclass: #XPathSyntaxException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathSyntaxException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for syntax errors in XPath expressions.!

XPathException subclass: #XPathTypeException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathTypeException commentStamp: 'monty 1/18/2015 13:55' prior: 0!
Invoked for type conversion errors.!

XPathException subclass: #XPathUndeclaredFunctionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredFunctionException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared functions.!

XPathException subclass: #XPathUndeclaredPrefixException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredPrefixException commentStamp: 'monty 6/15/2015 00:34' prior: 0!
Invoked for undeclared namespace prefixes used in name tests (only when one or more namespaces are set in the context).!

XPathException subclass: #XPathUndeclaredVariableException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredVariableException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared variables.!

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 06:02'!
% aNodeTestStringOrBlock
	"parent axis"
	(self hasParent
		and: [aNodeTestStringOrBlock asNodeTestBlock value: self parent])
		ifTrue: [
			"parent axis is a forward axis unlike ancestor or ancestor-or-self"
			^ (self nodeSetClass with: self parent)
				sortOrder: XPathLevelDocumentSortOrder new]
		ifFalse: [^ self nodeSetClass new]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:16'!
%% aNodeTestStringOrBlock
	"ancestor axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self ancestorNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:16'!
%%~ aNodeTestStringOrBlock
	"ancestor-or-self axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	(nodeTestBlock value: self)
		ifTrue: [nodeSet addLast: self].
	self ancestorNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:20'!
/ aNodeTestStringOrBlock
	"child axis"
	^ self nodeSetClass new! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:17'!
// aNodeTestStringOrBlock
	"descendant axis"
	^ self nodeSetClass new! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:15'!
//~ aNodeTestStringOrBlock
	"descendant-or-self axis"
	^ self ~ aNodeTestStringOrBlock! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:17'!
<< aNodeTestStringOrBlock
	"preceding axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self precedingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:19'!
<<< aNodeTestStringOrBlock
	"preceding-sibling axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self precedingSiblingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathLevelReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:19'!
>> aNodeTestStringOrBlock
	"following axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self followingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:20'!
>>> aNodeTestStringOrBlock
	"following-sibling axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self followingSiblingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathLevelDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:17'!
@ aNodeTestStringOrBlock
	"attribute axis"
	^ self nodeSetClass new! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:20'!
@@ aNodeTestStringOrBlock
	"namespace axis"
	^ self nodeSetClass new! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 1/16/2015 14:18'!
allNodesReverseDo: aBlock
	aBlock value: self! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 18:54'!
documentRoot
	"returns the root of the DOM tree, a document node if there is one or the
	last ancestor or self otherwise"
	| documentRoot |

	documentRoot := self.
	self ancestorNodesDo: [:each | documentRoot := each].
	^ documentRoot.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:42'!
followingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [each allNodesDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:42'!
followingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:38'!
hasExpandedName
	^ false! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ false! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 6/2/2015 07:39'!
lastAncestorOrSelfIn: aNode
	self parent = aNode parent
		ifFalse: [| lastAncestorOrSelf |
			lastAncestorOrSelf := self.
			[lastAncestorOrSelf hasParent]
				whileTrue: [
					lastAncestorOrSelf parent = aNode
						ifTrue: [^ lastAncestorOrSelf].
					lastAncestorOrSelf := lastAncestorOrSelf parent]].
	^ nil.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 6/30/2015 05:10'!
nodeSetClass
	^ XPathNodeSet! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:43'!
precedingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [each allNodesReverseDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:43'!
precedingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	"returns XPath node string-value"
	 ^ ''! !

!XMLNode methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/12/2015 20:28'!
xPath: anXPathOrXPathString
	^ anXPathOrXPathString asXPath in: self! !

!XMLNode methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/12/2015 20:40'!
xPath: anXPathOrXPathString context: aContext
	^ anXPathOrXPathString asXPath
		in: self
		context: aContext! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:18'!
~ aNodeTestStringOrBlock
	"self axis"
	(aNodeTestStringOrBlock asNodeTestBlock value: self)
		ifTrue: [
			^ (self nodeSetClass with: self)
				sortOrder: XPathLevelDocumentSortOrder new]
		ifFalse: [^ self nodeSetClass new]! !

XMLNode subclass: #XPathNamespaceNode
	instanceVariableNames: 'name uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNamespaceNode commentStamp: 'monty 2/10/2015 03:34' prior: 0!
This class models an element namespace mapping as a DOM node for compatibility with the XPath standard.!

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 3/22/2015 02:55'!
element: anElement name: aPrefix uri: aURI
	^ self new
		setElement: anElement
		name: aPrefix
		uri: aURI! !

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 3/10/2015 13:50'!
withXMLNamespaceOnElement: anElement
	^ self
		element: anElement
		name: 'xml'
		uri: XMLNamespaceScope xmlNamespaceURI! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 4/9/2015 02:08'!
= anObject
	"This is needed because namespace nodes aren't part of DOM trees
	and are created dynamically by XPath, so unless = is defined the union
	of two node sets could contain duplicate nodes for the same element
	namespace"

	self == anObject
		ifTrue: [^ true].

	self class == anObject class
		ifFalse: [^ false].

	"different elements don't share namespace nodes with the same name/uri
	according to the spec"
	^ self element = anObject element
		and: [self name = anObject name
			and: [self uri = anObject uri]].! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 12/23/2014 15:22'!
element
	^ parent! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 12/28/2014 06:21'!
expandedName
	^ self localName expandWithNamespaceURI: self namespaceURI! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 2/28/2015 14:13'!
hasNamespaceURI
	^ false! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 3/10/2015 14:12'!
hasPrefix
	"this returns true only if the name is prefixed, and namespace
	names cannot be prefixed"
	^ false! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 3/21/2015 23:11'!
hasPrefixedNamespaceURI: aURI
	^ false! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 3/10/2015 13:52'!
hash
	^ self name hash bitXor: self uri hash! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ true! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 13:52'!
localName
	^ self name! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 13:52'!
name
	^ name ifNil: [name := '']! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 3/10/2015 14:14'!
namespaceURI
	"spec says namespace nodes cannot be namespaced
	(the namespace part of the expanded name is null)"
	^ ''! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 3/10/2015 14:08'!
prefix
	"the name of a namespace node cannot be prefixed"
	^ ''! !

!XPathNamespaceNode methodsFor: 'initialization' stamp: 'monty 3/22/2015 02:55'!
setElement: anElement name: aPrefix uri: aURI
	"reuse parent inst var, like in XMLAttribute"
	parent := anElement.
	name := aPrefix.
	uri := aURI.! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self uri! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 1/26/2015 20:32'!
uri
	^ uri ifNil: [uri := '']! !

!XPathNamespaceNode methodsFor: 'printing' stamp: 'monty 3/10/2015 13:53'!
writeXMLOn: aWriter
	aWriter
		writeName:
			(self name
				ifEmpty: ['xmlns']
				ifNotEmpty: ['xmlns:', self name])
		escapedContentValue: self uri! !

!XMLElement methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:16'!
@ aNodeTestStringOrBlock
	"attribute axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asAttributeNodeTestBlock.
	self hasAttributes
		ifTrue: [
			self attributeNodesDo: [:each |
				(nodeTestBlock value: each)
					ifTrue: [nodeSet addLast: each]]].
	^ nodeSet sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XMLElement methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:16'!
@@ aNodeTestStringOrBlock
	"namespace axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNamespaceNodeTestBlock.
	self hasNamespaceNodes
		ifTrue: [
			self namespaceNodesDo: [:each |
				(nodeTestBlock value: each)
					ifTrue: [nodeSet addLast: each]]].
	^ nodeSet sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 2/9/2015 22:23'!
hasNamespaceNodes
	"elements have at least one node for the default xml namespace"
	^ self usesNamespaces! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 3/21/2015 23:11'!
hasPrefixedNamespaceURI: aURI
	^ self hasPrefix
		and: [self namespaceURI = aURI]! !

!XMLElement methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/26/2015 22:07'!
namespaceNodes
	| namespaceNodes |

	namespaceNodes := self newListForSelect.
	self namespaceNodesDo: [:each | namespaceNodes addLast: each].
	^ namespaceNodes.! !

!XMLElement methodsFor: '*XPath-Core-enumerating' stamp: 'monty 3/26/2015 23:29'!
namespaceNodesDo: aBlock
	"every element has a node for the default xml namespace.
	if it isn't explicitly defined, then it's first in order"
	self usesNamespaces
		ifFalse: [^ self].

	(self hasNamespaces
		and: [self namespaceScope includesPrefix: 'xml'])
		ifFalse: [aBlock value: (XPathNamespaceNode withXMLNamespaceOnElement: self)].

	self hasNamespaces
		ifTrue: [
			self namespaceScope prefixesAndURIsDo: [:prefix :uri |
				aBlock value:
					(XPathNamespaceNode
						element: self
						name: prefix
						uri: uri)]].! !

!Number class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathNumber! !

!Number class methodsFor: '*XPath-Core' stamp: 'monty 4/7/2015 09:15'!
xPathReadFrom: aStream
	| number |

	aStream xPathSkipSeparators.
	[number := Float readFrom: aStream]
		on: Error
		do: [:error | ^ Float nan].
	
	aStream xPathSkipSeparators.
	aStream atEnd
		ifFalse: [^ Float nan].

	^ number.! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//!!= anObject
	^ anObject xPathNotEqualsNumber: self! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//* anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//+ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//- anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 02:01'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//< anObject
	^ anObject xPathGreaterThanNumber: self! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//<= anObject
	^ (anObject xPathGreaterThanNumber: self)
		or: [anObject xPathEqualsNumber: self]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//= anObject
	^ anObject xPathEqualsNumber: self! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//> anObject
	^ anObject xPathLessThanNumber: self! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//>= anObject
	^ (anObject xPathLessThanNumber: self)
		or: [anObject xPathEqualsNumber: self]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//\\ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 12/22/2014 18:16'!
asXPathBoolean
	^ (self isZero or: [self isNaN]) not! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 12/23/2014 14:40'!
asXPathNumber
	^ self asFloat! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 08:50'!
asXPathString
	self isNaN
		ifTrue: [^ 'NaN'].
	self isZero
		ifTrue: [^ '0'].
	self isInfinite
		ifTrue: [
			self < 0
				ifTrue: [^ '-Infinity']
				ifFalse: [^ 'Infinity']].
	"overridden in gemstone version to use greaseString"
	^ self printString.! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:54'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self = each stringValue asXPathNumber]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:39'!
xPathEqualsNumber: aNumber
	^ self = aNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:46'!
xPathEqualsString: aString
	^ self = aString asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:48'!
xPathGreaterThanBoolean: aBoolean
	^ self > aBoolean asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathGreaterThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self > each stringValue asXPathNumber]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:39'!
xPathGreaterThanNumber: aNumber
	^ self > aNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:48'!
xPathGreaterThanString: aString
	^ self > aString asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:00'!
xPathLessThanBoolean: aBoolean
	^ self < aBoolean asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathLessThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self < each stringValue asXPathNumber]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:57'!
xPathLessThanNumber: aNumber
	^ self < aNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:57'!
xPathLessThanString: aString
	^ self < aString asXPathNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:54'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathNotEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self ~= each stringValue asXPathNumber]! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:54'!
xPathNotEqualsNumber: aNumber
	^ self ~= aNumber! !

!Number methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:55'!
xPathNotEqualsString: aString
	^ self ~= aString asXPathNumber! !

!XMLAttribute methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLAttribute methodsFor: '*XPath-Core-testing' stamp: 'monty 3/21/2015 23:11'!
hasPrefixedNamespaceURI: aURI
	"unprefixed attributes cannot be namespaced"
	^ self namespaceURI = aURI! !

!XMLAttribute methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self value! !

!String class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathString! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//!!= anObject
	^ anObject xPathNotEqualsString: self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//* anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//+ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//- anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 02:01'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//< anObject
	^ anObject xPathGreaterThanString: self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//<= anObject
	^ (anObject xPathGreaterThanString: self)
		or: [anObject xPathEqualsString: self]! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//= anObject
	^ anObject xPathEqualsString: self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//> anObject
	^ anObject xPathLessThanString: self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//>= anObject
	^ (anObject xPathLessThanString: self)
		or: [anObject xPathEqualsString: self]! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//\\ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 4/11/2015 04:20'!
asAttributeNodeTestBlock
	"parses string as a node test to produce a node test block where attributes
	are the principal node type"
	^ (XPathNodeTestParser
		on: self
		for:
			(XPathStringNodeTestParserHandler defaultNodeTestParserContextClass:
				XPathNodeTestParserAttributeContext)) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 4/11/2015 04:19'!
asNamespaceNodeTestBlock
	"parses string as a node test to produce a node test block where namespaces
	are the principal node type"
	^ (XPathNodeTestParser
		on: self
		for:
			(XPathStringNodeTestParserHandler defaultNodeTestParserContextClass:
				XPathNodeTestParserNamespaceContext)) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 4/11/2015 03:55'!
asNodeTestBlock
	"parses string as a node test to produce a node test block"
	^ (XPathNodeTestParser
		on: self
		for:
			(XPathStringNodeTestParserHandler defaultNodeTestParserContextClass:
				XPathNodeTestParserElementContext)) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/17/2014 14:19'!
asXPath
	^ XPath for: self! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self notEmpty! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 4/7/2015 09:07'!
asXPathNumber
	^ Number xPathReadFrom: self readStream! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 15:06'!
asXPathString
	^ self! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:03'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self = each stringValue]! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:54'!
xPathEqualsNumber: aNumber
	^ self asXPathNumber = aNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 02:52'!
xPathEqualsString: aString
	^ self = aString! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:04'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathNumber > aBoolean asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathGreaterThanNodeSet: aNodeSet
	| number |
	
	number := self asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number > each stringValue asXPathNumber].! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:05'!
xPathGreaterThanNumber: aNumber
	^ self asXPathNumber > aNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:04'!
xPathGreaterThanString: aString
	^ self asXPathNumber > aString asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:05'!
xPathLessThanBoolean: aBoolean
	^ self asXPathNumber < aBoolean asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathLessThanNodeSet: aNodeSet
	| number |
	
	number := self asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number < each stringValue asXPathNumber].! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:06'!
xPathLessThanNumber: aNumber
	^ self asXPathNumber < aNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:06'!
xPathLessThanString: aString
	^ self asXPathNumber < aString asXPathNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:03'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 3/25/2015 19:40'!
xPathNotEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self ~= each stringValue]! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:02'!
xPathNotEqualsNumber: aNumber
	^ self asXPathNumber ~= aNumber! !

!String methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 08:02'!
xPathNotEqualsString: aString
	^ self ~= aString! !

!PositionableStream methodsFor: '*XPath-Core-converting' stamp: 'monty 1/14/2015 03:20'!
asXPathReadStreamAdapter
	^ XPathReadStreamAdapter on: self! !

!PositionableStream methodsFor: '*XPath-Core-private' stamp: 'monty 4/7/2015 09:40'!
xPathSkipSeparators
	"peek when atEnd is not portable and may not return nil,
	so atEnd is tested for first"
	[self atEnd not
		and: [self peek xmlParserIsSeparator]]
		whileTrue: [self next]! !

!BlockClosure methodsFor: '*XPath-Core' stamp: 'monty 4/10/2015 03:51'!
asAttributeNodeTestBlock
	^ self! !

!BlockClosure methodsFor: '*XPath-Core' stamp: 'monty 4/10/2015 03:53'!
asNamespaceNodeTestBlock
	^ self! !

!BlockClosure methodsFor: '*XPath-Core' stamp: 'monty 12/31/2014 08:17'!
asNodeTestBlock
	^ self! !

Collection subclass: #XPathFunctionSet
	instanceVariableNames: 'functionsByName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFunctionSet commentStamp: 'monty 2/10/2015 03:01' prior: 0!
A set for XPath functions. Supports set composition with + and - and lookup of functions by name.
!

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 3/8/2015 11:44'!
default
	^ XPathBooleanFunction +
		XPathCeilingFunction +
		XPathConcatFunction +
		XPathContainsFunction +
		XPathCountFunction +
		XPathEndsWithFunction +
		XPathFalseFunction +
		XPathFloorFunction +
		XPathIDFunction +
		XPathLangFunction +
		XPathLocalNameFunction +
		XPathNameFunction +
		XPathNamespaceURIFunction +
		XPathNormalizeSpaceFunction +
		XPathNotFunction +
		XPathNumberFunction +
		XPathRoundFunction +
		XPathStartsWithFunction +
		XPathStringFunction +
		XPathStringLengthFunction +
		XPathSubstringAfterFunction +
		XPathSubstringBeforeFunction +
		XPathSubstringFunction +
		XPathSumFunction +
		XPathTranslateFunction +
		XPathTrueFunction! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 1/18/2015 15:23'!
new
	^ self new: 15! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 12/27/2014 17:02'!
new: aCapacity
	^ self basicNew initialize: aCapacity! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 1/19/2015 15:16'!
newFrom: aCollection
	"for portability"
	^ self withAll: aCollection! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 12/27/2014 17:09'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetWithFunctions: self! !

!XPathFunctionSet methodsFor: 'copying' stamp: 'monty 3/3/2015 04:30'!
, aCollection
	", is not defined for non-sequenceable collections on gemstone"
	^ self copy
		addAll: aCollection;
		yourself! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 12/29/2014 21:31'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetSubtractedFromFunctions: self! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 12/29/2014 21:18'!
= aFunctionSet
	self == aFunctionSet
		ifTrue: [^ true].

	(self class == aFunctionSet class
		and: [self size = aFunctionSet size])
		ifFalse: [^ false].

	^ self allSatisfy: [:each | aFunctionSet includes: each].! !

!XPathFunctionSet methodsFor: 'adding' stamp: 'monty 12/27/2014 16:56'!
add: aFunction
	^ functionsByName
		at: aFunction functionName
		put: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 1/15/2015 09:51'!
asFunctionSet
	^ self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 1/15/2015 09:53'!
asFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 12/29/2014 21:31'!
asFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 12/29/2014 21:22'!
asFunctionSetWithFunction: aFunction
	^ self copyWith: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/3/2015 04:18'!
asFunctionSetWithFunctions: aFunctionSet
	^ self, aFunctionSet! !

!XPathFunctionSet methodsFor: 'enumerating' stamp: 'monty 12/27/2014 16:59'!
do: aBlock
	functionsByName valuesDo: aBlock! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 2/10/2015 19:11'!
functionNamed: aFunctionName
	^  functionsByName at: aFunctionName! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 2/10/2015 19:12'!
functionNamed: aFunctionName ifAbsent: aBlock
	^  functionsByName
		at: aFunctionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'private' stamp: 'monty 1/19/2015 17:08'!
functionsByName
	^ functionsByName! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 12/29/2014 21:19'!
hash
	^ functionsByName hash! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 12/27/2014 17:10'!
includes: aFunction
	^ (functionsByName
		at: aFunction functionName
		ifAbsent: [^ false]) == aFunction! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 2/10/2015 19:15'!
includesFunctionNamed: aName
	^ functionsByName includesKey: aName! !

!XPathFunctionSet methodsFor: 'initialization' stamp: 'monty 12/27/2014 17:01'!
initialize: aCapacity
	functionsByName := Dictionary new: aCapacity! !

!XPathFunctionSet methodsFor: 'copying' stamp: 'monty 12/27/2014 03:55'!
postCopy
	functionsByName := functionsByName copy! !

!XPathFunctionSet methodsFor: 'removing' stamp: 'monty 12/27/2014 16:58'!
remove: aFunction ifAbsent: aBlock
	^ functionsByName
		removeKey: aFunction functionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 12/27/2014 03:59'!
size
	^ functionsByName size! !

!XMLDocument methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 18:55'!
documentRoot
	"returns the root of the DOM tree"
	^ self! !

!Boolean class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//!!= anObject
	^ anObject xPathNotEqualsBoolean: self! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:07'!
//* anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//+ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//- anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 02:00'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//< anObject
	^ anObject xPathGreaterThanBoolean: self! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//<= anObject
	^ (anObject xPathGreaterThanBoolean: self)
		or: [anObject xPathEqualsBoolean: self]! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//= anObject
	^ anObject xPathEqualsBoolean: self! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//> anObject
	^ anObject xPathLessThanBoolean: self! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//>= anObject
	^ (anObject xPathLessThanBoolean: self)
		or: [anObject xPathEqualsBoolean: self]! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 3/1/2015 13:08'!
//\\ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 17:29'!
asXPathNumber
	"Gemstone has TrueClass/FalseClass instead of True/False subclasses,
	so this is implemented in the superclass for portability"
	^ self
		ifTrue: [1.0]
		ifFalse: [0.0]! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 17:28'!
asXPathString
	"Gemstone has TrueClass/FalseClass instead of True/False subclasses,
	so this is implemented in the superclass for portability"
	^ self
		ifTrue: ['true']
		ifFalse: ['false']! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 06:16'!
xPathEqualsBoolean: aBoolean
	^ self = aBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 12/25/2014 15:41'!
xPathEqualsNodeSet: aNodeSet
	^ self = aNodeSet asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 06:16'!
xPathEqualsNumber: aNumber
	^ self = aNumber asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 12/24/2014 06:17'!
xPathEqualsString: aString
	^ self = aString asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:17'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathNumber > aBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:18'!
xPathGreaterThanNodeSet: aNodeSet
	^ self asXPathNumber > aNodeSet asXPathBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:42'!
xPathGreaterThanNumber: aNumber
	^ self asXPathNumber > aNumber asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:46'!
xPathGreaterThanString: aString
	^ self asXPathNumber > aString asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:00'!
xPathLessThanBoolean: aBoolean
	^ self asXPathNumber < aBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 09:18'!
xPathLessThanNodeSet: aNodeSet
	^ self asXPathNumber < aNodeSet asXPathBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:46'!
xPathLessThanNumber: aNumber
	^ self asXPathNumber < aNumber asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:46'!
xPathLessThanString: aString
	^ self asXPathNumber < aString asXPathNumber! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:36'!
xPathNotEqualsBoolean: aBoolean
	^ self ~= aBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:37'!
xPathNotEqualsNodeSet: aNodeSet
	^ self ~= aNodeSet asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:36'!
xPathNotEqualsNumber: aNumber
	^ self ~= aNumber asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core-private' stamp: 'monty 1/13/2015 07:35'!
xPathNotEqualsString: aString
	^ self ~= aString asXPathBoolean! !

!XMLString methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self string! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 12/28/2014 06:21'!
expandedName
	^ self localName expandWithNamespaceURI: self namespaceURI! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 2/28/2015 14:13'!
hasNamespaceURI
	^ false! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:58'!
hasPrefix
	^ false! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 3/21/2015 23:11'!
hasPrefixedNamespaceURI: aURI
	^ false! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 14:13'!
localName
	^ self name! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 13:21'!
name
	^ self target! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 13:21'!
namespaceURI
	"The spec says the namespace URI part of a PI expanded name is null"
	^ ''! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 14:05'!
prefix
	^ ''! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self data! !

XMLNodeList subclass: #XPathNodeSet
	instanceVariableNames: 'set sortOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNodeSet commentStamp: 'monty 2/10/2015 03:47' prior: 0!
An XPath node set is an ordered node list that has no duplicates. Node sets produced by XPath expression evaluation will be sorted in either document order or reverse document order.!

!XPathNodeSet class methodsFor: 'private' stamp: 'monty 1/15/2015 13:52'!
errorCannotConvert: anObject
	XPathTypeException
		formatSignal: 'Cannot convert object of class {1} to node set'
		with: anObject class name! !

!XPathNodeSet class methodsFor: 'instance creation' stamp: 'monty 4/15/2015 11:47'!
new
	^ self new: 10! !

!XPathNodeSet class methodsFor: 'instance creation' stamp: 'monty 1/15/2015 13:51'!
xPathNewFrom: anObject
	"no conversions are specified from other types to node sets"
	(anObject isKindOf: XPathNodeSet)
		ifFalse: [self errorCannotConvert: anObject].
	^ anObject.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:18'!
% aNodeTestStringOrBlock
	"parent axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				parentAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first % aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
%% aNodeTestStringOrBlock
	"ancestor axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				ancestorAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first %% aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
%%~ aNodeTestStringOrBlock
	"ancestor-or-self axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				ancestorOrSelfAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first %%~ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/29/2015 19:01'!
& aNodeSet
	"redefined here for portability"
	^ self intersection: aNodeSet! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
/ aNodeTestStringOrBlock
	"child axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				childAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first / aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
// aNodeTestStringOrBlock
	"descendant axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				descendantAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first // aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:07'!
//!!= anObject
	^ anObject xPathNotEqualsNodeSet: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:07'!
//* anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:08'!
//+ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:08'!
//- anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/13/2015 02:03'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:08'!
//< anObject
	^ anObject xPathGreaterThanNodeSet: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:08'!
//<= anObject
	^ (anObject xPathGreaterThanNodeSet: self)
		or: [anObject xPathEqualsNodeSet: self]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:08'!
//= anObject
	^ anObject xPathEqualsNodeSet: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:08'!
//> anObject
	^ anObject xPathLessThanNodeSet: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:08'!
//>= anObject
	^ (anObject xPathLessThanNodeSet: self)
		or: [anObject xPathEqualsNodeSet: self]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/1/2015 13:08'!
//\\ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
//~ aNodeTestStringOrBlock
	"descendant-or-self axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				descendantOrSelfAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first //~ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
<< aNodeTestStringOrBlock
	"preceding axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				precedingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first << aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
<<< aNodeTestStringOrBlock
	"preceding-sibling axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				precedingSiblingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first <<< aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
>> aNodeTestStringOrBlock
	"following axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				followingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first >> aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
>>> aNodeTestStringOrBlock
	"following-sibling axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				followingSiblingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first >>> aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 5/12/2015 22:34'!
?? aThreeArgumentBlockOrPosition
	"filters with three-argument filter block or position index"
	| copy |

	copy := self copyEmpty.
	aThreeArgumentBlockOrPosition isNumber
		ifTrue: [
			copy addLast:
				(self
					at: aThreeArgumentBlockOrPosition rounded
					ifAbsent: [^ copy])]
		ifFalse: [| contextSize |
			contextSize := self size.
			1 to: contextSize do: [:i | | node result |
				node := self at: i.
				(result :=
					aThreeArgumentBlockOrPosition
						value: node
						value: i
						value: contextSize) isNumber
					ifTrue: [
						result rounded = i
							ifTrue: [copy addLast: node]]
					ifFalse: [
						result asXPathBoolean
							ifTrue: [copy addLast: node]]].
			"filtering does not change sort order"
			copy sortOrderFrom: self].
	^ copy.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 4/10/2015 03:52'!
@ aNodeTestStringOrBlock
	"attribute axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				attributeAxisOn: self
				select: aNodeTestStringOrBlock asAttributeNodeTestBlock].
	self size = 1
		ifTrue: [^ self first @ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 4/10/2015 03:53'!
@@ aNodeTestStringOrBlock
	"namespace axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				namespaceAxisOn: self
				select: aNodeTestStringOrBlock asNamespaceNodeTestBlock].
	self size = 1
		ifTrue: [^ self first @@ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/29/2015 19:01'!
\ aNodeSet
	"redefined here for portability"
	^ self difference: aNodeSet! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 6/7/2015 06:11'!
afterAdding: aNode at: anIndex
	| oldSize |

	oldSize := self set size.
	(self set
		add: aNode;
		size) > oldSize
		ifFalse: [self movedNode: aNode to: anIndex].
	sortOrder := nil.
	super
		afterAdding: aNode
		at: anIndex.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 23:33'!
afterAddingLast: aNode
	| oldSize |

	oldSize := self set size.
	(self set
		add: aNode;
		size) > oldSize
		ifFalse: [self movedNode: aNode to: oldSize].
	sortOrder := nil.
	super afterAddingLast: aNode.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/24/2015 10:49'!
afterRemoving: aNode
	self set remove: aNode.
	"removing does not change order"
	super afterRemoving: aNode.! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathBoolean
	^ self notEmpty! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathNumber
	^ self asXPathString asXPathNumber! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 3/25/2015 20:44'!
asXPathString
	^ self firstInDocumentOrder
		ifNil: ['']
		ifNotNil: [:node | node stringValue]! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copy
	"copies that don't add or replace keep sort order"
	^ super copy sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copyAfter: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyAfter: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copyAfterLast: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyAfterLast: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copyFrom: aStartIndex to: anEndIndex
	"copies that don't add or replace keep sort order"
	^ (super
		copyFrom: aStartIndex
		to: anEndIndex) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:35'!
copyUpTo: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyUpTo: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:35'!
copyUpToLast: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyUpToLast: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:35'!
copyWithout: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyWithout: anObject) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 8/16/2015 21:34'!
copyWithoutAll: aCollection
	"copies that don't add or replace keep sort order"
	^ (super copyWithoutAll: aCollection) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 21:35'!
difference: aNodeSet
	^ (self copyWithoutAll: aNodeSet) sort! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrder
	^ self sortOrder firstInDocumentOrderFrom: self! !

!XPathNodeSet methodsFor: 'testing' stamp: 'monty 1/16/2015 05:26'!
includes: aNode
	^ self set includes: aNode! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 21:35'!
intersection: aNodeSet
	^ (self select: [:each | aNodeSet includes: each]) sort! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/9/2015 01:31'!
movedNode: aNode to: anIndex
	| i |

	(i :=
		self
			indexOf: aNode
			otherThan: anIndex) > 0
		ifTrue: [
			"since a node is just being moved, the collection
			is changed directly without notifying observers"
			collection removeAt: i]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/13/2015 22:15'!
reject: aBlock
	"reject doesn't change sort order"
	^ (super reject: aBlock) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 02:49'!
reverseInPlace
	self
		reverseInPlaceFrom: 1
		to: collection size! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 02:49'!
reverseInPlaceFrom: aStart to: anEnd
	| start end |

	start := aStart.
	end := anEnd.
	[start < end]
		whileTrue: [
			self swap: start with: end.
			start := start + 1.
			end := end - 1].! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 6/1/2015 00:11'!
reverseReadStream
	^ XPathReverseReadStream on: self! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/5/2015 17:52'!
select: aBlock
	"select doesn't change sort order"
	^ (super select: aBlock) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 4/15/2015 11:45'!
set
	"IdentitySet is not used because namespace nodes implement ="
	^ set ifNil: [set := Set new: self capacity]! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 1/26/2015 19:01'!
sort
	self sortOrder documentOrderSort: self! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 6/7/2015 00:44'!
sort: aSortBlock
	super sort: aSortBlock.
	self sortOrder: nil.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 6/5/2015 01:07'!
sortOrder
	sortOrder
		ifNil: [
			self size > 1
				ifTrue: [sortOrder := XPathUnknownSortOrder new]
				ifFalse: [
					"safe for node sets with <= 1 node"
					sortOrder := XPathLevelDocumentSortOrder new]].
	^ sortOrder.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/26/2015 17:48'!
sortOrder: aSortOrder
	sortOrder := aSortOrder! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 4/14/2015 07:26'!
sortOrderFrom: aNodeSet
	sortOrder := aNodeSet sortOrder! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 8/16/2015 21:33'!
stringValue
	"returns XPath string-value for the first node in document order"
	^ self asXPathString! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 3/27/2015 01:16'!
stringValues
	"returns XPath string-values of nodes"
	^ self collect: [:each | each stringValue]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 01:17'!
stringValuesDo: aBlock
	"enumerates XPath string-values of nodes"
	self do: [:each | aBlock value: each stringValue]! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 6/7/2015 06:10'!
swap: aFirstIndex with: aSecondIndex
	super
		swap: aFirstIndex
		with: aSecondIndex.
	self sortOrder: nil.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 21:11'!
union: aNodeSet
	"XPath node set union operator"
	^ self copy
		addAll: aNodeSet;
		sort! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/13/2015 07:04'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:41'!
xPathEqualsNodeSet: aNodeSet
	| stringValues |

	stringValues := Set new: self size.
	self do: [:each | stringValues add: each stringValue].
	^ aNodeSet anySatisfy: [:node | stringValues includes: node stringValue].! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:41'!
xPathEqualsNumber: aNumber
	^ self anySatisfy: [:each | each stringValue asXPathNumber = aNumber]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:41'!
xPathEqualsString: aString
	^ self anySatisfy: [:each | each stringValue = aString]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 12/25/2014 15:34'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathBoolean asXPathNumber > aBoolean asXPathNumber! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:41'!
xPathGreaterThanNodeSet: aNodeSet
	| least |

	aNodeSet do: [:each | | number |
		number := each stringValue asXPathNumber.
		(least isNil
			or: [number < least])
			ifTrue: [least := number]].
	^ least notNil
		and: [self anySatisfy: [:each | each stringValue asXPathNumber > least]].! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:41'!
xPathGreaterThanNumber: aNumber
	^ self anySatisfy: [:each | each stringValue asXPathNumber > aNumber]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:41'!
xPathGreaterThanString: aString
	| number |

	number := aString asXPathNumber.
	^ self anySatisfy: [:each | each stringValue asXPathNumber > number]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/13/2015 09:11'!
xPathLessThanBoolean: aBoolean
	^ self asXPathBoolean asXPathNumber < aBoolean asXPathNumber! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:41'!
xPathLessThanNodeSet: aNodeSet
	| greatest |

	aNodeSet do: [:each | | number |
		number := each stringValue asXPathNumber.
		(greatest isNil
			or: [number > greatest])
			ifTrue: [greatest := number]].
	^ greatest notNil
		and: [self anySatisfy: [:each | each stringValue asXPathNumber < greatest]].! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:41'!
xPathLessThanNumber: aNumber
	^ self anySatisfy: [:each | each stringValue asXPathNumber < aNumber]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/13/2015 07:23'!
xPathLessThanString: aString
	| number |

	number := aString asXPathNumber.
	^ self anySatisfy: [:each | each asXPathNumber < number]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/13/2015 07:00'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:42'!
xPathNotEqualsNodeSet: aNodeSet
	| stringValues |

	"should return true according to spec when aNodeSet and self each have at least
	one node that don't have the same string-values"
	stringValues := self collect: [:each | each stringValue].
	aNodeSet do: [:node | | stringValue |
		stringValue := node stringValue.
		stringValues do: [:each |
			each = stringValue
				ifFalse: [^ true]]].
	^ false.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:42'!
xPathNotEqualsNumber: aNumber
	^ self anySatisfy: [:each | each stringValue asXPathNumber ~= aNumber]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2015 19:42'!
xPathNotEqualsString: aString
	^ self anySatisfy: [:each | each stringValue ~= aString]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/29/2015 19:01'!
| aNodeSet
	"redefined here for portability"
	^ self union: aNodeSet! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/13/2015 12:19'!
~ aNodeTestStringOrBlock
	"self axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				selfAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first ~ aNodeTestStringOrBlock].
	^ self copyEmpty.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-enumerating' stamp: 'monty 1/16/2015 14:20'!
allNodesReverseDo: aBlock
	self hasChildren
		ifTrue: [self nodes reverseDo: [:each | each allNodesReverseDo: aBlock]].
	aBlock value: self.! !

!Object class methodsFor: '*XPath-Core' stamp: 'monty 1/20/2015 19:23'!
xPathNewFrom: anObject
	^ anObject! !

Object subclass: #XPath
	instanceVariableNames: 'xPathSource compiledXPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPath class
	instanceVariableNames: 'compiledXPathCache'!

!XPath commentStamp: 'monty 6/15/2015 06:39' prior: 0!
This class evaluates XPath expressions in the context of XMLNodes with optional custom context objects to control evaluation. It supports complete XPath 1.0 syntax with extensions.

Basic usage:
	| doc path result context |
	doc := XMLDOMParser parse: '<test>test</test>'.
	path := XPath for: '/test'.
	result := path in: doc.

	"with a custom context"
	path := XPath for: '/*[name() = $name]'.
	context :=  XPathContext new.
	context variableAt: 'name' put: 'test'.
	result := path in: doc context: context.

The syntax extensions are:
- Prefix wildcards in name tests like "*:name"
- Expanded name tests like "Q{namespaceURI}localName" that allow easier namespace testing 
- The element(), attribute(), and namespace() type tests that can also have embedded name tests like "element(name)"

Unlike standard XPath, by default prefixes in node tests are matched against literal prefixes of nodes, so you don't need to declare prefixes in the context before using them in node tests. Declaring at least one prefix triggers standard behavior. See XPathContext for more.

XPath expressions can be encoded directly in Smalltalk using special binary selectors on XMLNodes and  XMLNodeSets:
	xmlNode //  'entry' / '*' /'link' @ 'href'.!

XPath class
	instanceVariableNames: 'compiledXPathCache'!

!XPath class methodsFor: 'accessing' stamp: 'monty 2/8/2015 19:29'!
clearCompiledXPathCache
	"self clearCompiledXPathCache"
	compiledXPathCache ifNotNil: [compiledXPathCache clear]! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/20/2015 02:51'!
compiledXPathCache
	^ compiledXPathCache
		ifNil: [compiledXPathCache := XMLKeyValueCache maxSize: 512]! !

!XPath class methodsFor: 'private' stamp: 'monty 6/15/2015 06:12'!
compiledXPathCacheAt: anXPathSourceString
	^ self compiledXPathCache at: anXPathSourceString! !

!XPath class methodsFor: 'private' stamp: 'monty 2/17/2015 08:55'!
compiledXPathCacheAt: anXPathSourceString ifAbsent: aBlock
	^ self compiledXPathCache
		at: anXPathSourceString
		ifAbsent: aBlock! !

!XPath class methodsFor: 'private' stamp: 'monty 2/17/2015 08:50'!
compiledXPathCacheAt: anXPathSourceString put: aCompiledXPath
	^ self compiledXPathCache
		at: anXPathSourceString
		put: aCompiledXPath! !

!XPath class methodsFor: 'instance creation' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString
	^ self new xPathSource: anXPathSourceString
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString in: aNode
	^ (self for: anXPathSourceString) in: aNode
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString in: aNode context: aContext
	^ (self for: anXPathSourceString)
		in: aNode
		context: aContext! !

!XPath class methodsFor: 'class initialization' stamp: 'monty 4/16/2015 02:23'!
initialize
	"
	self initialize
	"

	self clearCompiledXPathCache.! !

XPath initialize!

!XPath class methodsFor: 'accessing' stamp: 'monty 1/15/2015 04:49'!
maxCachedCompiledXPaths
	^ self compiledXPathCache maxSize! !

!XPath class methodsFor: 'accessing' stamp: 'monty 1/15/2015 04:50'!
maxCachedCompiledXPaths: anInteger
	self compiledXPathCache maxSize: anInteger! !

!XPath methodsFor: 'converting' stamp: 'monty 1/17/2015 04:38'!
asXPath
	^ self! !

!XPath methodsFor: 'compiling' stamp: 'monty 3/2/2015 15:33'!
compile
	^ self compileWith: self compilerClass new! !

!XPath methodsFor: 'compiling' stamp: 'monty 3/2/2015 15:33'!
compileWith: anXPathCompiler
	compiledXPath := anXPathCompiler compile: self xPathSource.
	self class
		compiledXPathCacheAt: self xPathSource
		put: compiledXPath.
	^ compiledXPath.! !

!XPath methodsFor: 'accessing' stamp: 'monty 3/2/2015 15:33'!
compiledXPath
	^ compiledXPath ifNil: [
		compiledXPath :=
			self class
				compiledXPathCacheAt: self xPathSource
				ifAbsent: [self compile]]! !

!XPath methodsFor: 'accessing' stamp: 'monty 12/22/2014 03:12'!
compilerClass
	^ XPathCompiler! !

!XPath methodsFor: 'accessing' stamp: 'monty 1/19/2015 08:26'!
contextClass
	^ XPathContext! !

!XPath methodsFor: 'evaluating' stamp: 'monty 5/11/2015 20:59'!
evaluate
	"used to evaluate expressions that don't use a context node"
	^ self in: nil! !

!XPath methodsFor: 'evaluating' stamp: 'monty 6/1/2015 19:39'!
in: aNode
	"evaluate in context of aNode"
	^ self
		in: aNode
		context: self contextClass new! !

!XPath methodsFor: 'evaluating' stamp: 'monty 6/1/2015 23:22'!
in: aNode context: aContext
	"evaluate in context of aNode with aContext"
	^ self compiledXPath
		value: aNode
		value: aContext! !

!XPath methodsFor: 'printing' stamp: 'monty 4/22/2015 16:29'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self xPathSource;
		nextPut: $).! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/9/2015 20:21'!
xPathSource
	^ xPathSource! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/9/2015 20:21'!
xPathSource: anXPathSourceString
	xPathSource := anXPathSourceString! !

Object subclass: #XPathAxis
	instanceVariableNames: 'axisSpecifier replacementSelector defaultNodeTestParserContextClass isImplicit isStartOfRelativeLocationPath isFirstAxis'
	classVariableNames: 'AxisSpecifiers'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathAxis commentStamp: 'monty 4/17/2015 02:16' prior: 0!
This class holds the current axis while a step is being parsed and maps them to selectors and parser context classes.!

!XPathAxis class methodsFor: 'private' stamp: 'monty 4/10/2015 07:00'!
axisSpecifiers
	^ AxisSpecifiers! !

!XPathAxis class methodsFor: 'private' stamp: 'monty 4/11/2015 09:56'!
axisSpecifiersTemplate
	^ #(
		#('ancestor'           '%%'  element)
		#('ancestor-or-self'   '%%~' element)
		#('attribute'          '@'   attribute)
		#('child'              '/'   element)
		#('descendant'         '//'  element)
		#('descendant-or-self' '//~' element)
		#('following'          '>>'  element)
		#('following-sibling'  '>>>' element)
		#('namespace'          '@@'  namespace)
		#('parent'             '%'   element)
		#('preceding'          '<<'  element)
		#('preceding-sibling'  '<<<' element)
		#('self'               '~'   element)
		#('%%'                 '%%'  element)
		#('%%~'                '%%~' element)
		#('@'                  '@'   attribute)
		#('@@'                 '@@'  namespace)
		#('>>'                 '>>'  element)
		#('>>>'                '>>>' element)
		#('%'                  '%'   element)
		#('<<'                 '<<'  element)
		#('<<<'                '<<<' element)
		#('~'                  '~'   element)
	)! !

!XPathAxis class methodsFor: 'class initialization' stamp: 'monty 4/15/2015 06:48'!
initialize
	"self initialize"

	self initializeAxisSpecifiers.! !

XPathAxis initialize!

!XPathAxis class methodsFor: 'class initialization' stamp: 'monty 4/11/2015 09:59'!
initializeAxisSpecifiers
	AxisSpecifiers := Dictionary new.
	self axisSpecifiersTemplate do: [:threeElementArray |
		| axisSpecifier replacementSelector principalNodeType defaultNodeTestParserContextClass |

		axisSpecifier := threeElementArray first.
		replacementSelector := threeElementArray second.
		principalNodeType := threeElementArray third.
		defaultNodeTestParserContextClass :=
			principalNodeType = #attribute
				ifTrue: [XPathNodeTestParserAttributeContext]
				ifFalse: [
					principalNodeType = #namespace
						ifTrue: [XPathNodeTestParserNamespaceContext]
						ifFalse: [XPathNodeTestParserElementContext]].

		AxisSpecifiers
			at: axisSpecifier
			put: replacementSelector -> defaultNodeTestParserContextClass].! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/13/2015 11:27'!
axisSpecifier
	^ axisSpecifier! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 4/16/2015 12:49'!
axisSpecifier: anAxisSpecifier
	anAxisSpecifier = axisSpecifier
		ifFalse: [
			axisSpecifier := anAxisSpecifier.
			replacementSelector := nil.
			defaultNodeTestParserContextClass := nil].
	"now explicit"
	isImplicit := false.! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 4/16/2015 11:48'!
beFirstAxis
	isFirstAxis := true! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 4/16/2015 12:46'!
beStartOfRelativeLocationPath
	isStartOfRelativeLocationPath := true! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 4/11/2015 04:10'!
defaultNodeTestParserContextClass
	^ defaultNodeTestParserContextClass
		ifNil: [
			self lookupAxisSpecifier.
			defaultNodeTestParserContextClass]! !

!XPathAxis methodsFor: 'private' stamp: 'monty 4/10/2015 07:36'!
errorUnrecognizedAxisSpecifier
	XPathSyntaxException
		formatSignal: 'Unrecognized axis specifier "{1}"'
		with: self axisSpecifier! !

!XPathAxis methodsFor: 'initialization' stamp: 'monty 4/16/2015 12:45'!
initialize
	super initialize.
	self resetToImplicitAxis.! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 4/16/2015 11:48'!
isFirstAxis
	^ isFirstAxis! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 4/16/2015 12:45'!
isImplicitAxis
	^ isImplicit! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 1/14/2015 02:34'!
isStartOfRelativeLocationPath
	^ isStartOfRelativeLocationPath! !

!XPathAxis methodsFor: 'private' stamp: 'monty 4/11/2015 10:00'!
lookupAxisSpecifier
	| association |

	association :=
		AxisSpecifiers
			at: self axisSpecifier
			ifAbsent: [self errorUnrecognizedAxisSpecifier].
	replacementSelector := association key.
	defaultNodeTestParserContextClass := association value.! !

!XPathAxis methodsFor: 'printing' stamp: 'monty 4/22/2015 16:29'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self axisSpecifier;
		nextPut: $).! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 4/11/2015 04:10'!
replacementSelector
	^ replacementSelector
		ifNil: [
			self lookupAxisSpecifier.
			replacementSelector]! !

!XPathAxis methodsFor: 'initialization' stamp: 'monty 4/16/2015 14:07'!
resetToImplicitAxis
	axisSpecifier := 'child'.
	replacementSelector := '/'.
	defaultNodeTestParserContextClass := XPathNodeTestParserElementContext.
	isImplicit := true.
	isFirstAxis := false.
	isStartOfRelativeLocationPath := false.! !

Object subclass: #XPathCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

!XPathCompiler commentStamp: 'monty 1/18/2015 06:22' prior: 0!
This class compiles XPath expressions by first translating them into Smalltalk using an XPathExpressionParser and handler and then compiling the result with the system compiler.!

!XPathCompiler methodsFor: 'compiling' stamp: 'monty 1/12/2015 05:01'!
compile: aStringOrStream
	^ self compileWithParser:
		(self parserClass
			on: aStringOrStream
			for: self parserHandlerClass new)! !

!XPathCompiler methodsFor: 'private' stamp: 'monty 2/10/2015 01:56'!
compileSource: aString
	"overridden in Gemstone version"
	^ Compiler evaluate: aString! !

!XPathCompiler methodsFor: 'compiling' stamp: 'monty 1/11/2015 10:07'!
compileWithParser: aParser
	^ self compileSource: aParser parse! !

!XPathCompiler methodsFor: 'accessing' stamp: 'monty 1/8/2015 05:56'!
parserClass
	^ XPathExpressionParser! !

!XPathCompiler methodsFor: 'accessing' stamp: 'monty 1/11/2015 10:12'!
parserHandlerClass
	^ XPathExpressionParserHandler! !

Object subclass: #XPathContext
	instanceVariableNames: 'variables functions namespaceScope functionStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext commentStamp: 'monty 6/15/2015 00:32' prior: 0!
An XPathContext controls evaluation of XPath expressions. Contexts have a function library, variable bindings, and namespace mappings.

By default, qualified name tests like 'prefix:name' and wildcard tests like 'prefix:*' will match against the prefix directly. This isn't like the standard, where prefixes in node tests must be declared in the context before evaluation and the namespace they're bound to is matched against the (non-default) namespace of the node, but it's easier to use.

To get standard behavior, just declare at least one prefix in the context before evaluation.!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext class methodsFor: 'accessing' stamp: 'monty 1/18/2015 05:53'!
defaultFunctions
	^ defaultFunctions ifNil: [defaultFunctions := XPathFunctionSet default]! !

!XPathContext class methodsFor: 'accessing' stamp: 'monty 3/8/2015 11:46'!
defaultFunctions: aFunctionSet
	"can be used to replace default function set with a custom function set"
	defaultFunctions := aFunctionSet! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:49'!
functions: aFunctionSet
	^ self new functions: aFunctionSet! !

!XPathContext class methodsFor: 'class initialization' stamp: 'monty 3/8/2015 11:45'!
initialize
	"self initialize"

	self defaultFunctions: nil! !

XPathContext initialize!

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
namespaces: anAssociationCollection
	^ self new declareNamespaces: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
variables: anAssociationCollection
	^ self new variables: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection functions: aFunctionSet
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection;
		functions: aFunctionSet! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 12:07'!
addFunction: aFunction
	functions := self functions + aFunction! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 1/19/2015 08:24'!
declareNamespaces: anAssociationCollection
	self namespaceScope mapPrefixesAndURIs: anAssociationCollection! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/21/2015 23:11'!
declarePrefix: aPrefix uri: aURI
	self namespaceScope
		mapPrefix: aPrefix
		to: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:01'!
errorUndeclaredFunction: aFunctionName
	XPathUndeclaredFunctionException
		formatSignal: 'Undeclared function {1}()'
		with: aFunctionName! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/5/2015 07:05'!
errorUndeclaredPrefix: aPrefix
	XPathUndeclaredPrefixException
		formatSignal: 'Prefix "{1}" was not declared in the XPath context'
		with: aPrefix! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:02'!
errorUndeclaredVariable: aVariableName
	XPathUndeclaredVariableException
		formatSignal: 'Undeclared variable reference ${1}'
		with: aVariableName! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/10/2015 19:20'!
function: aFunctionName contextNode: aContextNode
	^ (self functions
		functionNamed: aFunctionName
		ifAbsent: [self errorUndeclaredFunction: aFunctionName])
		context: self
		contextNode: aContextNode! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 08:54'!
functions
	^ functions ifNil: [functions := self class defaultFunctions]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 12:07'!
functions: aFunctionSet
	functions := aFunctionSet! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 01:02'!
hasNamespaces
	^ namespaceScope notNil
		and: [namespaceScope hasNamespaces]! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/10/2015 22:05'!
includesFunction: aFunction
	^ self functions includes: aFunction! !

!XPathContext methodsFor: 'testing' stamp: 'monty 1/17/2015 04:48'!
includesVariable: aVariableName
	^ self variables includesKey: aVariableName! !

!XPathContext methodsFor: 'initialization' stamp: 'monty 1/1/2015 00:54'!
initialize
	super initialize.
	functionStack := OrderedCollection new.! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 20:52'!
isDeclaredPrefix: aPrefix
	^ self namespaceScope includesPrefix: aPrefix! !

!XPathContext methodsFor: 'testing' stamp: 'monty 3/21/2015 23:11'!
isDeclaredPrefix: aPrefix uri: aURI
	^ self namespaceScope
		includesPrefix: aPrefix
		mappedTo: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 12/30/2014 03:46'!
namespaceScope
	^ namespaceScope ifNil: [namespaceScope := XMLNamespaceScope new]! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/14/2015 04:57'!
pop
	^ functionStack removeLast! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/22/2015 02:54'!
prefixesOfNamespaceURI: aURI
	^ self namespaceScope prefixesOfNamespaceURI: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/14/2015 04:57'!
push: anObject
	^ functionStack addLast: anObject! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 12:07'!
removeFunction: aFunction
	functions := self functions - aFunction! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/5/2015 07:05'!
resolvePrefix: aPrefix
	^ self namespaceScope
		resolvePrefix: aPrefix
		ifUnresolvable: [self errorUndeclaredPrefix: aPrefix]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:01'!
testForAttributeWithPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isAttribute
					and: [node hasPrefixedNamespaceURI: namespaceURI]]]
		ifFalse: [
			^ [:node |
				node isAttribute
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:02'!
testForAttributeWithPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isAttribute
					and: [node localName = aLocalName
						and: [node hasPrefixedNamespaceURI: namespaceURI]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithPrefix: aPrefix.
			^ [:node |
				node isAttribute
					and: [node name = name]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:02'!
testForElementWithPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isElement
					and: [node hasPrefixedNamespaceURI: namespaceURI]]]
		ifFalse: [
			^ [:node |
				node isElement
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/25/2015 01:02'!
testForElementWithPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isElement
					and: [node localName = aLocalName
						and: [node hasPrefixedNamespaceURI: namespaceURI]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithPrefix: aPrefix.
			^ [:node |
				node isElement
					and: [node name = name]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 4/10/2015 02:58'!
testForNamespaceWithPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isNamespace
					and: [node hasPrefixedNamespaceURI: namespaceURI]]]
		ifFalse: [
			^ [:node |
				node isNamespace
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 4/10/2015 02:59'!
testForNamespaceWithPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceURI |
			namespaceURI := self resolvePrefix: aPrefix.
			^ [:node |
				node isNamespace
					and: [node localName = aLocalName
						and: [node hasPrefixedNamespaceURI: namespaceURI]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithPrefix: aPrefix.
			^ [:node |
				node isNamespace
					and: [node name = name]]]! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 12/30/2014 03:48'!
undeclarePrefix: aPrefix
	self namespaceScope unmapPrefix: aPrefix! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/18/2015 14:00'!
variableAt: aVariableName
	^ self variables
		at: aVariableName
		ifAbsent: [self errorUndeclaredVariable: aVariableName]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsent: aBlock
	^ self variables
		at: aVariableName
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsentPut: aBlock
	^ self variables
		at: aVariableName
		ifAbsentPut: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:48'!
variableAt: aVariableName put: aValue
	^ self variables
		at: aVariableName
		put: aValue! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/17/2015 04:49'!
variables
	^ variables ifNil: [variables := Dictionary new]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 2/13/2015 00:55'!
variables: anAssociationCollection
	variables :=
		anAssociationCollection isDictionary
			ifTrue: [anAssociationCollection]
			ifFalse: [Dictionary withAll: anAssociationCollection]! !

Object subclass: #XPathFunction
	instanceVariableNames: 'context contextNode totalPushedArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

XPathFunction class
	instanceVariableNames: 'returnType functionName minArguments maxArguments argumentTypes'!

!XPathFunction commentStamp: 'monty 6/15/2015 00:38' prior: 0!
An abstract class for XPath functions. Subclasses need to override the class functionPrototype method to return a string with an XPath function prototype and then implement the instance-side function method to implement the function. Arguments are passed using a stack because functions can have optional arguments or even an unbounded number of arguments, and are popped off in LIFO order (last arg popped off first).

Arguments and return values are automatically converted to the types specified in the prototype.!

XPathFunction class
	instanceVariableNames: 'returnType functionName minArguments maxArguments argumentTypes'!

XPathFunction subclass: #XPathBooleanFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathBooleanFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath boolean conversion function.!

!XPathBooleanFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 17:30'!
functionPrototype
	^ 'boolean boolean(object)'! !

!XPathBooleanFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	^ self pop! !

XPathFunction subclass: #XPathCeilingFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCeilingFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath ceiling function.!

!XPathCeilingFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:19'!
functionPrototype
	^ 'number ceiling(number)'! !

!XPathCeilingFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	^ self pop ceiling! !

XPathFunction subclass: #XPathConcatFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathConcatFunction commentStamp: 'monty 3/13/2015 21:27' prior: 0!
XPath string concatenation function. Concatenates two or more strings.!

!XPathConcatFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 17:32'!
functionPrototype
	^ 'string concat(string, string, string*)'! !

!XPathConcatFunction methodsFor: 'invoking' stamp: 'monty 4/3/2015 07:52'!
function
	| concatenation |

	concatenation := self pop.
	[self hasPushedArguments]
		whileTrue: [concatenation := self pop, concatenation].
	^ concatenation.! !

XPathFunction subclass: #XPathContainsFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathContainsFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath contains substring function.!

!XPathContainsFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:37'!
functionPrototype
	^ 'boolean contains(string, string)'! !

!XPathContainsFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:51'!
function
	| substring |

	substring := self pop.
	"use findString:startingAt: for portability"
	^ (self pop
		findString: substring
		startingAt: 1) > 0! !

XPathFunction subclass: #XPathCountFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCountFunction commentStamp: 'monty 6/15/2015 00:40' prior: 0!
XPath node set count (size) function.!

!XPathCountFunction class methodsFor: 'accessing' stamp: 'monty 12/25/2014 00:08'!
functionPrototype
	^ 'number count(node-set)'! !

!XPathCountFunction methodsFor: 'invoking' stamp: 'monty 12/25/2014 00:09'!
function
	^ self pop size! !

XPathFunction subclass: #XPathEndsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathEndsWithFunction commentStamp: 'monty 6/15/2015 00:40' prior: 0!
Non-standard; added for completeness with starts-with().!

!XPathEndsWithFunction class methodsFor: 'accessing' stamp: 'monty 2/12/2015 20:24'!
functionPrototype
	^ 'boolean ends-with(string, string)'! !

!XPathEndsWithFunction methodsFor: 'invoking' stamp: 'monty 2/12/2015 20:25'!
function
	| substring |

	substring := self pop.
	^ self pop endsWith: substring.! !

XPathFunction subclass: #XPathFalseFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFalseFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath false function.!

!XPathFalseFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:27'!
functionPrototype
	^ 'boolean false()'! !

!XPathFalseFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:51'!
function
	^ false! !

XPathFunction subclass: #XPathFloorFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFloorFunction commentStamp: 'monty 12/22/2014 21:18' prior: 0!
XPath floor function.!

!XPathFloorFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:17'!
functionPrototype
	^ 'number floor(number)'! !

!XPathFloorFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:55'!
function
	^ self pop floor! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 12/29/2014 21:32'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetWithFunction: self! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 12/29/2014 21:33'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetSubtractedFromFunction: self! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:00'!
argumentTypes
	^ argumentTypes
		ifNil: [
			self parseFunctionPrototype.
			argumentTypes]! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/15/2015 09:51'!
asFunctionSet
	^ XPathFunctionSet with: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/15/2015 09:54'!
asFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 12/29/2014 21:34'!
asFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/17/2015 12:15'!
asFunctionSetWithFunction: aFunction
	^ self asFunctionSet
		add: aFunction;
		yourself! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/17/2015 12:16'!
asFunctionSetWithFunctions: aFunctionSet
	^ self asFunctionSet
		addAll: aFunctionSet;
		yourself! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 12/22/2014 18:03'!
classForTypeName: aTypeName
	aTypeName = 'object'
		ifTrue: [^ Object].
	aTypeName = 'boolean'
		ifTrue: [^ Boolean].
	aTypeName = 'string'
		ifTrue: [^ String].
	aTypeName = 'number'
		ifTrue: [^ Number].
	aTypeName = 'node-set'
		ifTrue: [^ XPathNodeSet].
	^ nil.! !

!XPathFunction class methodsFor: 'instance creation' stamp: 'monty 12/29/2014 06:24'!
context: aContext contextNode: aContextNode
	^ self new
		setContext: aContext
		contextNode: aContextNode! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:16'!
functionName
	^ functionName
		ifNil: [
			self parseFunctionPrototype.
			functionName]! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:36'!
functionPrototype
	"should return a protype string. see subclasses for examples."
	self subclassResponsibility! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:23'!
maxArguments
	^ maxArguments
		ifNil: [
			self parseFunctionPrototype.
			maxArguments]! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:23'!
minArguments
	^ minArguments
		ifNil: [
			self parseFunctionPrototype.
			minArguments]! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 3/10/2015 19:26'!
parseFunctionPrototype
	"self allSubclassesDo: [:each | each parseFunctionPrototype]"

	(XPathFunctionPrototypeParser
		on: self functionPrototype
		for: (XPathFunctionPrototypeParserHandler function: self))
		parse! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/23/2014 14:30'!
returnType
	^ returnType
		ifNil: [
			self parseFunctionPrototype.
			returnType]! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 12/23/2014 14:31'!
setReturnType: aReturnType functionName: aName minArguments: aMinimum maxArguments: aMaximum argumentTypes: anArgumentTypeCollection
	returnType := aReturnType.
	functionName := aName.
	minArguments := aMinimum.
	maxArguments := aMaximum.
	argumentTypes := anArgumentTypeCollection asArray.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/23/2014 14:42'!
argumentTypeAt: anInteger
	^ self argumentTypes at: (anInteger min: self argumentTypes size)! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
argumentTypes
	^ self class argumentTypes! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/24/2014 23:45'!
context
	^ context! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/14/2015 04:58'!
contextNode
	^ contextNode! !

!XPathFunction methodsFor: 'private' stamp: 'monty 1/18/2015 13:59'!
errorTooFewArguments
	XPathArgumentNumberException
		formatSignal: '{1}() requires at least {2} arguments'
		with: self functionName
		with: self minArguments! !

!XPathFunction methodsFor: 'private' stamp: 'monty 1/18/2015 13:59'!
errorTooManyArguments
	XPathArgumentNumberException
		formatSignal: '{1}() accepts at most {2} arguments'
		with: self functionName
		with: self maxArguments! !

!XPathFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	self subclassResponsibility! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
functionName
	^ self class functionName! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/27/2014 03:50'!
functionPrototype
	^ self class functionPrototype! !

!XPathFunction methodsFor: 'testing' stamp: 'monty 4/3/2015 07:51'!
hasPushedArguments
	^ totalPushedArguments > 0! !

!XPathFunction methodsFor: 'invoking' stamp: 'monty 12/27/2014 04:08'!
invoke
	totalPushedArguments < self minArguments
		ifTrue: [self errorTooFewArguments].

	^ self returnType xPathNewFrom: self function.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
maxArguments
	^ self class maxArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
minArguments
	^ self class minArguments! !

!XPathFunction methodsFor: 'stack' stamp: 'monty 2/9/2015 22:08'!
pop
	totalPushedArguments := totalPushedArguments - 1.
	^ context pop.! !

!XPathFunction methodsFor: 'printing' stamp: 'monty 4/23/2015 14:19'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self functionPrototype; "print: quotes"
		nextPut: $).! !

!XPathFunction methodsFor: 'stack' stamp: 'monty 4/3/2015 07:56'!
push: anArgument
	self maxArguments
		ifNotNil: [:maxArguments |
			totalPushedArguments >= maxArguments
				ifTrue: [self errorTooManyArguments]].

	totalPushedArguments := totalPushedArguments + 1.
	^ context push:
		((self argumentTypeAt: totalPushedArguments)
			xPathNewFrom: anArgument).! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/23/2014 14:38'!
returnType
	^ self class returnType! !

!XPathFunction methodsFor: 'initialization' stamp: 'monty 12/29/2014 06:25'!
setContext: aContext contextNode: aContextNode
	context := aContext.
	contextNode := aContextNode.
	totalPushedArguments := 0.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/26/2014 03:32'!
totalPushedArguments
	^ totalPushedArguments! !

XPathFunction subclass: #XPathIDFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathIDFunction commentStamp: 'monty 3/9/2015 21:50' prior: 0!
XPath id() function to select elements from the document of the context node by ID.!

!XPathIDFunction class methodsFor: 'accessing' stamp: 'monty 3/8/2015 11:05'!
functionPrototype
	^ 'node-set id(object)'! !

!XPathIDFunction methodsFor: 'private' stamp: 'monty 3/25/2015 00:59'!
addElementsWithIDs: anIDSet from: aDocument to: aNodeSet
	| doctypeDefinition elementsAndIDAttributes |

	((doctypeDefinition := aDocument doctypeDefinition) notNil
		and: [doctypeDefinition hasElementIDValidator])
		ifFalse: [^ self].
	elementsAndIDAttributes :=
		doctypeDefinition elementIDValidator elementsAndIDAttributes.

	aDocument allElementsDo: [:each |
		each hasAttributes
			ifTrue: [
				elementsAndIDAttributes
					at: each name
					ifPresent: [:idAttribute |
						((each includesAttribute: idAttribute)
							and: [anIDSet includes: (each attributeAt: idAttribute)])
							ifTrue: [aNodeSet add: each]]]].! !

!XPathIDFunction methodsFor: 'invoking' stamp: 'monty 3/25/2015 19:40'!
function
	| object ids document nodeSet |

	object := self pop.
	ids := Set new.
	(object isKindOf: XPathNodeSet)
		ifTrue: [
			object do: [:each |
				self
					splitSpaceSeparatedIDs: each stringValue
					into: ids]]
		ifFalse: [
			self
				splitSpaceSeparatedIDs: object asXPathString
				into: ids].

	nodeSet := XPathNodeSet new.
	(ids notEmpty
		and: [self contextNode notNil
			and: [(document := self contextNode document) notNil]])
		ifTrue: [
			self
				addElementsWithIDs: ids
				from: document
				to: nodeSet].
	^ nodeSet.! !

!XPathIDFunction methodsFor: 'private' stamp: 'monty 4/5/2015 01:29'!
splitSpaceSeparatedIDs: anIDString into: anIDSet
	| startIndex|

	1 to: anIDString size do: [:i | | nextChar |
		(nextChar := anIDString at: i) xmlParserIsSeparator
			ifTrue: [
				startIndex
					ifNotNil: [
						anIDSet add: (anIDString copyFrom: startIndex to: i - 1).
						startIndex := nil]]
			ifFalse: [
				startIndex
					ifNil: [startIndex := i]]].
	startIndex
		ifNotNil: [
			anIDSet add:
				(anIDString copyFrom: startIndex to: anIDString size)].! !

XPathFunction subclass: #XPathLangFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLangFunction commentStamp: 'monty 3/25/2015 04:12' prior: 0!
XPath lang() function to test if the context node is in the scope of an xml:lang attribute value matching the argument.!

!XPathLangFunction class methodsFor: 'accessing' stamp: 'monty 12/23/2014 15:18'!
functionPrototype
	^ 'boolean lang(string)'! !

!XPathLangFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:55'!
function
	| language |

	language := self pop.
	^ self contextNode isInLanguage: language.! !

XPathFunction subclass: #XPathLocalNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLocalNameFunction commentStamp: 'monty 12/27/2014 00:36' prior: 0!
XPath local name function.!

!XPathLocalNameFunction class methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:19'!
functionPrototype
	^ 'string local-name(node-set?)'! !

!XPathLocalNameFunction methodsFor: 'invoking' stamp: 'monty 4/3/2015 07:52'!
function
	| node |

	self hasPushedArguments
		ifTrue: [node := self pop firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil and: [node hasExpandedName])
		ifTrue: [^ node localName]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNameFunction commentStamp: 'monty 3/5/2015 15:46' prior: 0!
XPath name function. Returns expanded name or local name of a node or empty string if node has no name. Operates on argument node or the context node if called with no arguments.!

!XPathNameFunction class methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:22'!
functionPrototype
	^ 'string name(node-set?)'! !

!XPathNameFunction methodsFor: 'invoking' stamp: 'monty 4/3/2015 07:52'!
function
	| node |

	self hasPushedArguments
		ifTrue: [node := self pop firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil and: [node hasExpandedName])
		ifTrue: [| namespaceURI |
			(self context hasNamespaces
				and: [(namespaceURI := node namespaceURI) notEmpty
					and: [node hasPrefix]])
				ifTrue: [
					((self context prefixesOfNamespaceURI: namespaceURI)
						ifEmpty: [^ node localName]
						ifNotEmpty: [:prefixes |
							^ node localName qualifyWithPrefix: prefixes anyOne])]
				ifFalse: [^ node name]]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathNamespaceURIFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNamespaceURIFunction commentStamp: 'monty 12/27/2014 00:27' prior: 0!
XPath namespace URI function.!

!XPathNamespaceURIFunction class methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:20'!
functionPrototype
	^ 'string namespace-uri(node-set?)'! !

!XPathNamespaceURIFunction methodsFor: 'invoking' stamp: 'monty 4/3/2015 07:52'!
function
	| node |

	self hasPushedArguments
		ifTrue: [node := self pop firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil and: [node hasExpandedName])
		ifTrue: [^ node namespaceURI]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNormalizeSpaceFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNormalizeSpaceFunction commentStamp: 'monty 6/15/2015 00:41' prior: 0!
XPath whitespace normalization function to remove leading and trailing whitespace and turn whitespace sequences into single spaces.!

!XPathNormalizeSpaceFunction class methodsFor: 'accessing' stamp: 'monty 12/25/2014 04:35'!
functionPrototype
	^ 'string normalize-space(string?)'! !

!XPathNormalizeSpaceFunction methodsFor: 'invoking' stamp: 'monty 4/4/2015 23:24'!
function
	| string writeStream isInWhitespace |

	self hasPushedArguments
		ifTrue: [string := self pop]
		ifFalse: [string := self contextNode].

	writeStream := (String new: string size) writeStream.
	isInWhitespace := false.
	string do: [:each |
		each xmlParserIsSeparator
			ifTrue: [
				isInWhitespace
					ifFalse: [isInWhitespace := true]]
			ifFalse: [
				isInWhitespace
					ifTrue: [
						writeStream xmlParserAtBeginning
							ifFalse: [writeStream nextPut: $ ].
						isInWhitespace := false].
				writeStream nextPut: each]].
	^ writeStream contents.! !

XPathFunction subclass: #XPathNotFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNotFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath negation function.!

!XPathNotFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:10'!
functionPrototype
	^ 'boolean not(boolean)'! !

!XPathNotFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:57'!
function
	^ self pop not! !

XPathFunction subclass: #XPathNumberFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNumberFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number conversion function.!

!XPathNumberFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:11'!
functionPrototype
	^ 'number number(object?)'! !

!XPathNumberFunction methodsFor: 'invoking' stamp: 'monty 4/3/2015 07:52'!
function
	self hasPushedArguments
		ifTrue: [^ self pop]
		ifFalse: [^ XPathNodeSet with: self contextNode]! !

XPathFunction subclass: #XPathRoundFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathRoundFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number rounding function.!

!XPathRoundFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:20'!
functionPrototype
	^ 'number round(number)'! !

!XPathRoundFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:58'!
function
	^ self pop rounded! !

XPathFunction subclass: #XPathStartsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStartsWithFunction commentStamp: 'monty 2/10/2015 02:59' prior: 0!
XPath string prefix testing function.!

!XPathStartsWithFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:25'!
functionPrototype
	^ 'boolean starts-with(string, string)'! !

!XPathStartsWithFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:59'!
function
	| substring |

	substring := self pop.
	^ self pop beginsWith: substring.! !

XPathFunction subclass: #XPathStringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringFunction commentStamp: 'monty 12/22/2014 20:01' prior: 0!
XPath string conversion function.!

!XPathStringFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 17:30'!
functionPrototype
	^ 'string string(object?)'! !

!XPathStringFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:59'!
function
	^ self pop! !

XPathFunction subclass: #XPathStringLengthFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringLengthFunction commentStamp: 'monty 12/22/2014 21:24' prior: 0!
XPath string length function.
!

!XPathStringLengthFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:22'!
functionPrototype
	^ 'number string-length(string?)'! !

!XPathStringLengthFunction methodsFor: 'invoking' stamp: 'monty 4/3/2015 07:52'!
function
	self hasPushedArguments
		ifTrue: [^ self pop size]
		ifFalse: [^ self contextNode stringValue size]! !

XPathFunction subclass: #XPathSubstringAfterFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringAfterFunction commentStamp: 'monty 6/15/2015 04:48' prior: 0!
XPath function to return the substring after another substring.!

!XPathSubstringAfterFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:48'!
functionPrototype
	^ 'string substring-after(string, string)'! !

!XPathSubstringAfterFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:59'!
function
	| substring string indexOfSubstring |

	substring := self pop.
	string := self pop.
	(indexOfSubstring :=
		string
			findString: substring
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: indexOfSubstring + substring size
				to: string size]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringBeforeFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringBeforeFunction commentStamp: 'monty 6/15/2015 04:48' prior: 0!
XPath function to return the substring before another substring.!

!XPathSubstringBeforeFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:40'!
functionPrototype
	^ 'string substring-before(string, string)'! !

!XPathSubstringBeforeFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:54'!
function
	| substring string indexOfSubstring |

	substring := self pop.
	string := self pop.
	(indexOfSubstring :=
		string
			findString: substring
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: 1
				to:indexOfSubstring - 1]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringFunction commentStamp: 'monty 6/15/2015 04:48' prior: 0!
XPath substring function. First argument is the source string, second is the one-based position, and third is the substring length.!

!XPathSubstringFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:53'!
functionPrototype
	^ 'string substring(string, number, number?)'! !

!XPathSubstringFunction methodsFor: 'invoking' stamp: 'monty 2/10/2015 06:36'!
function
	| string start length |

	self totalPushedArguments > 2
		ifTrue: [
			length := self pop rounded.
			start := self pop rounded.
			string := self pop]
		ifFalse: [
			start := self pop rounded.
			string := self pop.
			length := string size - start + 1].

	(length > 0 and: [start <= string size])
		ifTrue: [
			^ string
				copyFrom: (start max: 1)
				to: ((start max: 1) + length - 1 min: string size)]
		ifFalse: [^ '']	.! !

XPathFunction subclass: #XPathSumFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSumFunction commentStamp: 'monty 6/15/2015 00:44' prior: 0!
XPath node set sum function.!

!XPathSumFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:06'!
functionPrototype
	^ 'number sum(node-set)'! !

!XPathSumFunction methodsFor: 'invoking' stamp: 'monty 3/25/2015 19:42'!
function
	^ self pop
		inject: 0
		into: [:i :each | i + each stringValue asXPathNumber]! !

XPathFunction subclass: #XPathTranslateFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathTranslateFunction commentStamp: 'monty 6/15/2015 00:44' prior: 0!
XPath function to replace/delete all occurances of certain characters in a string.!

!XPathTranslateFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:57'!
functionPrototype
	^ 'string translate(string, string, string)'! !

!XPathTranslateFunction methodsFor: 'invoking' stamp: 'monty 4/1/2015 22:59'!
function
	| replacementTable replacementString searchString sourceString writeStream |

	replacementTable := IdentityDictionary new.
	replacementString := self pop.
	searchString := self pop.
	1 to: searchString size do: [:i |
		replacementTable
			at: (searchString at: i)
			ifAbsentPut: (replacementString at: i ifAbsent: [nil])].

	sourceString := self pop.
	writeStream  := (String new: sourceString size) writeStream.
	sourceString do: [:each |	
		(replacementTable at: each ifAbsent: [each])
			ifNotNil: [:nextChar | writeStream  nextPut: nextChar]].
	^ writeStream  contents.! !

XPathFunction subclass: #XPathTrueFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathTrueFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath true function.!

!XPathTrueFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:24'!
functionPrototype
	^ 'boolean true()'! !

!XPathTrueFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:53'!
function
	^ true! !

Object subclass: #XPathNodeSetSorter
	instanceVariableNames: 'nodeSet nodeSetSize nodeSetCollection nodeSetSet mustVisitNamespaces mustVisitAttributes totalSorted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNodeSetSorter commentStamp: 'monty 6/10/2015 03:06' prior: 0!
Sorts an unsorted node set into document order.!

!XPathNodeSetSorter class methodsFor: 'instance creation' stamp: 'monty 6/9/2015 01:45'!
on: aNodeSet
	^ self new on: aNodeSet! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 6/11/2015 02:05'!
errorNodesLackSharedDocumentRoot
	XPathDOMException signal: 'Cannot sort nodes without shared document root'! !

!XPathNodeSetSorter methodsFor: 'initialization' stamp: 'monty 7/4/2015 02:52'!
on: aNodeSet
	nodeSet := aNodeSet.
	nodeSetSize := aNodeSet size.
	nodeSetCollection := aNodeSet collection.
	nodeSetSet := aNodeSet set.
	totalSorted := 0.! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 7/5/2015 02:39'!
prescanNodesForSharedParent
	| sharedParent |

	sharedParent := nodeSetCollection first parent.
	mustVisitNamespaces := false.
	mustVisitAttributes := false.
	nodeSetCollection do: [:each |
		each isNamespace
			ifTrue: [mustVisitNamespaces := true].
		each isAttribute
			ifTrue: [mustVisitAttributes := true].
		sharedParent
			ifNotNil: [
				each parent == sharedParent
					ifFalse: [sharedParent := nil]]].
	^ sharedParent.! !

!XPathNodeSetSorter methodsFor: 'sorting' stamp: 'monty 7/5/2015 07:45'!
sort
	nodeSetSize > 1
		ifTrue: [
			self prescanNodesForSharedParent
				ifNil: [self sortVisitingAllNodes]
				ifNotNil: [:sharedParent | self sortVisitingNodesOfSharedParent: sharedParent]]! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 7/4/2015 12:24'!
sortNode: aNode
	(nodeSetSet includes: aNode)
		ifTrue: [
			nodeSetCollection
				at: (totalSorted := totalSorted + 1)
				put: aNode]! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 7/4/2015 13:00'!
sortVisitingAllNodes
	nodeSetCollection first documentRoot allNodesDo: [:node |
		self sortNode: node.
		node isElement
			ifTrue: [
				(mustVisitNamespaces
					and: [node hasNamespaceNodes])
					ifTrue: [node namespaceNodesDo: [:each | self sortNode: each]].
				(mustVisitAttributes
					and: [node hasAttributes])
					ifTrue: [node attributeNodesDo: [:each |self sortNode: each]]].
		totalSorted = nodeSetSize
			ifTrue: [
				nodeSet sortOrder: XPathDocumentSortOrder new.
				^ self]].

	self errorNodesLackSharedDocumentRoot.! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 7/4/2015 12:27'!
sortVisitingNodesOfSharedParent: aSharedParent
	(mustVisitNamespaces
		and: [aSharedParent hasNamespaceNodes])
		ifTrue: [aSharedParent namespaceNodesDo: [:each | self sortNode: each]].
	(mustVisitAttributes
		and: [aSharedParent hasAttributes])
		ifTrue: [aSharedParent attributeNodesDo: [:each | self sortNode: each]].
	aSharedParent hasChildren
		ifTrue: [aSharedParent nodesDo: [:each | self sortNode: each]].

	nodeSet sortOrder:
		(mustVisitNamespaces | mustVisitAttributes
			ifTrue: [XPathDocumentSortOrder new]
			ifFalse: [XPathLevelDocumentSortOrder new]).! !

Object subclass: #XPathNodeTestParserContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

XPathNodeTestParserContext class
	instanceVariableNames: 'instance'!

!XPathNodeTestParserContext commentStamp: 'monty 4/12/2015 11:26' prior: 0!
This is an abstract base class for node test parser contexts. Instances of subclasses are immutable and shared.!

XPathNodeTestParserContext class
	instanceVariableNames: 'instance'!

XPathNodeTestParserContext subclass: #XPathNodeTestParserAttributeContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserAttributeContext commentStamp: 'monty 4/11/2015 04:14' prior: 0!
A context for parsing node tests where attributes are the principal node type.!

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:16'!
handleTestForAnyNameWith: aHandler
	aHandler handleTestForAttributeWithAnyName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:47'!
handleTestForLocalName: aLocalName with: aHandler
	aHandler handleTestForAttributeWithLocalName: aLocalName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 13:26'!
handleTestForName: aName with: aHandler
	aHandler handleTestForAttributeWithName: aName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleTestForAttributeWithNamespaceURI: aURI
		localName: aLocalName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 4/15/2015 08:00'!
handleTestForNamespaceURI: aURI with: aHandler
	aHandler handleTestForAttributeWithNamespaceURI: aURI! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:43'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleTestForAttributeWithPrefix: aPrefix
		localName: aLocalName! !

!XPathNodeTestParserAttributeContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:06'!
handleTestForPrefix: aPrefix with: aHandler
	aHandler handleTestForAttributeWithPrefix: aPrefix! !

XPathNodeTestParserAttributeContext subclass: #XPathNodeTestParserAttributeTypeTestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserAttributeTypeTestContext commentStamp: 'monty 4/11/2015 04:14' prior: 0!
A context for parsing the arguments of an attribute() type test.!

!XPathNodeTestParserAttributeTypeTestContext methodsFor: 'testing' stamp: 'monty 4/11/2015 04:13'!
canHandleTypeTests
	^ false! !

!XPathNodeTestParserAttributeTypeTestContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:27'!
handleEmptyTestWith: aHandler
	aHandler handleTestForAttributeWithAnyName! !

!XPathNodeTestParserContext class methodsFor: 'instance creation' stamp: 'monty 2/22/2015 00:01'!
new
	"these classes are shared immutable for efficiency"
	^ instance ifNil: [instance := self basicNew initialize]! !

!XPathNodeTestParserContext methodsFor: 'testing' stamp: 'monty 4/11/2015 04:13'!
canHandleTypeTests
	^ true! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:25'!
handleEmptyTestWith: aHandler
	aHandler handleEmptyTest! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:16'!
handleTestForAnyNameWith: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:26'!
handleTestForAnyNodeTypeWith: aHandler
	aHandler handleTestForAnyNodeType! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:25'!
handleTestForCommentTypeWith: aHandler
	aHandler handleTestForCommentType! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:46'!
handleTestForLocalName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 08:18'!
handleTestForName: aName with: aHandler
	self subclassResponsibility
! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/15/2015 07:32'!
handleTestForNamespaceURI: aURI with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:41'!
handleTestForPITypeWith: aHandler
	aHandler handleTestForPIWithAnyName! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:25'!
handleTestForPIWithName: aName with: aHandler
	aHandler handleTestForPIWithName: aName! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:42'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:03'!
handleTestForPrefix: aPrefix with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:26'!
handleTestForTextTypeWith: aHandler
	aHandler handleTestForTextType! !

XPathNodeTestParserContext subclass: #XPathNodeTestParserElementContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserElementContext commentStamp: 'monty 4/11/2015 03:43' prior: 0!
A context for parsing node tests where elements are the principal node type.!

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:16'!
handleTestForAnyNameWith: aHandler
	aHandler handleTestForElementWithAnyName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:47'!
handleTestForLocalName: aLocalName with: aHandler
	aHandler handleTestForElementWithLocalName: aLocalName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 13:27'!
handleTestForName: aName with: aHandler
	aHandler handleTestForElementWithName: aName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/22/2015 02:53'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleTestForElementWithNamespaceURI: aURI
		localName: aLocalName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 4/15/2015 08:00'!
handleTestForNamespaceURI: aURI with: aHandler
	aHandler handleTestForElementWithNamespaceURI: aURI! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:43'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleTestForElementWithPrefix: aPrefix
		localName: aLocalName! !

!XPathNodeTestParserElementContext methodsFor: 'handling' stamp: 'monty 3/1/2015 11:04'!
handleTestForPrefix: aPrefix with: aHandler
	aHandler handleTestForElementWithPrefix: aPrefix! !

XPathNodeTestParserElementContext subclass: #XPathNodeTestParserElementTypeTestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserElementTypeTestContext commentStamp: 'monty 4/11/2015 04:14' prior: 0!
A context for parsing the arguments of an element() type test.!

!XPathNodeTestParserElementTypeTestContext methodsFor: 'testing' stamp: 'monty 4/11/2015 04:13'!
canHandleTypeTests
	^ false! !

!XPathNodeTestParserElementTypeTestContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:28'!
handleEmptyTestWith: aHandler
	aHandler handleTestForElementWithAnyName! !

XPathNodeTestParserContext subclass: #XPathNodeTestParserNamespaceContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserNamespaceContext commentStamp: 'monty 4/11/2015 03:43' prior: 0!
A context for parsing node tests where namespaces are the principal node type.!

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:28'!
handleTestForAnyNameWith: aHandler
	aHandler handleTestForNamespaceWithAnyName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:29'!
handleTestForLocalName: aLocalName with: aHandler
	aHandler handleTestForNamespaceWithLocalName: aLocalName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:29'!
handleTestForName: aName with: aHandler
	aHandler handleTestForNamespaceWithName: aName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:29'!
handleTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleTestForNamespaceWithNamespaceURI: aURI
		localName: aLocalName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/15/2015 08:00'!
handleTestForNamespaceURI: aURI with: aHandler
	aHandler handleTestForNamespaceWithNamespaceURI: aURI! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:30'!
handleTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleTestForNamespaceWithPrefix: aPrefix
		localName: aLocalName! !

!XPathNodeTestParserNamespaceContext methodsFor: 'handling' stamp: 'monty 4/10/2015 02:30'!
handleTestForPrefix: aPrefix with: aHandler
	aHandler handleTestForNamespaceWithPrefix: aPrefix! !

XPathNodeTestParserNamespaceContext subclass: #XPathNodeTestParserNamespaceTypeTestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserNamespaceTypeTestContext commentStamp: 'monty 4/14/2015 10:09' prior: 0!
A context for parsing the arguments of a namespace() type test.!

!XPathNodeTestParserNamespaceTypeTestContext methodsFor: 'testing' stamp: 'monty 4/14/2015 10:08'!
canHandleTypeTests
	^ false! !

!XPathNodeTestParserNamespaceTypeTestContext methodsFor: 'handling' stamp: 'monty 4/14/2015 10:08'!
handleEmptyTestWith: aHandler
	aHandler handleTestForNamespaceWithAnyName! !

Object subclass: #XPathParser
	instanceVariableNames: 'handler inputStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParser commentStamp: 'monty 5/11/2015 04:49' prior: 0!
This is a base class for XPath parsers that parse input using parser handlers.!

XPathParser subclass: #XPathExpressionParser
	instanceVariableNames: 'currentAxis nodeTestParser'
	classVariableNames: 'AbbreviatedAxisSpecifierCharacters'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParser commentStamp: 'monty 2/10/2015 02:58' prior: 0!
This class parses XPath expressions. It understands all of XPath 1.0 syntax and supports some extensions like abbreviated syntax for other axis specifiers.!

!XPathExpressionParser class methodsFor: 'class initialization' stamp: 'monty 1/10/2015 09:03'!
initialize
	"self initialzie"

	self initializeAbbreviatedAxisSpecifierCharacters! !

XPathExpressionParser initialize!

!XPathExpressionParser class methodsFor: 'class initialization' stamp: 'monty 1/22/2015 15:52'!
initializeAbbreviatedAxisSpecifierCharacters
	(AbbreviatedAxisSpecifierCharacters := BitmapCharacterSet new)
		addAll: '%@~<>'! !

!XPathExpressionParser methodsFor: 'testing' stamp: 'monty 6/17/2015 00:58'!
atDigit
	inputStream peek
		ifNil: [^ false]
		ifNotNil: [:nextChar | ^ nextChar isDigit]! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 4/2/2015 08:19'!
errorExpectedEndPredicate
	self errorExpected: '"]" end of predicate'! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/21/2015 18:29'!
errorExpectedNodeTest
	self errorExpected: 'node test after axis'! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/14/2015 04:35'!
errorExpectedStep
	self errorExpected: 'location path step'! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/26/2015 20:32'!
nextAdditionalSteps
	self peekForAdditionalSteps
		ifFalse: [self errorExpectedStep]! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 10:48'!
nextAdditiveExpression
	handler handleStartAdditiveExpression.
	self nextMultiplicativeExpression.
	[self peekForAdditiveOperator]
		whileTrue: [self nextMultiplicativeExpression].
	handler handleEndAdditiveExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/11/2015 00:11'!
nextAndExpression
	| totalShortCircuited |

	handler handleStartAndExpression.
	self nextEqualityExpression.
	totalShortCircuited := 0.
	[self peekForAndOperator]
		whileTrue: [
			handler handleStartShortCircuitAnd.
			totalShortCircuited := totalShortCircuited + 1.
			self nextEqualityExpression].
	handler
		handleEndShortCircuited: totalShortCircuited;
		handleEndAndExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:19'!
nextArgument
	handler handleStartFunctionArgument.
	self nextOrExpression.
	handler handleEndFunctionArgument.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/18/2015 15:21'!
nextDigitsOnWriteStream
	"first digit"
	writeStream nextPut: inputStream next.
	[self atDigit]
		whileTrue: [writeStream nextPut: inputStream next].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 11:10'!
nextEqualityExpression
	handler handleStartEqualityExpression.
	self nextRelationalExpression.
	[self peekForEqualityOperator]
		whileTrue: [self nextRelationalExpression].
	handler handleEndEqualityExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 04:08'!
nextFilterExpression
	self
		nextPrimaryExpression;
		peekForPredicates! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:17'!
nextFunctionCall
	| name |

	name := self nextName.
	name = 'position'
		ifTrue: [
			handler handlePositionFunctionCall.
			^ self nextEmptyArgumentList].
	name = 'last'
		ifTrue: [
			handler handleLastFunctionCall.
			^ self nextEmptyArgumentList].

	handler handleStartFunctionCall: name.
	self nextArgumentList.
	handler handleEndFunctionCall.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 07:43'!
nextMultiplicativeExpression
	handler handleStartMultiplicativeExpression.
	self nextUnaryExpression.
	[self peekForMultiplicativeOperator]
		whileTrue: [self nextUnaryExpression].
	handler handleEndMultiplicativeExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/11/2015 00:11'!
nextOrExpression
	| totalShortCircuited |

	handler handleStartOrExpression.
	self nextAndExpression.
	totalShortCircuited := 0.
	[self peekForOrOperator]
		whileTrue: [
			handler handleStartShortCircuitOr.
			totalShortCircuited := totalShortCircuited + 1.
			self nextAndExpression].
	handler
		handleEndShortCircuited: totalShortCircuited;
		handleEndOrExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/22/2015 22:30'!
nextPathExpression
	handler handleStartPathExpression.
	self peekForLocationPathExpression
		ifFalse: [
			self nextFilterExpression.
			self peekForLocationPathSeparator
				ifTrue: [self nextAdditionalSteps]].
	handler handleEndPathExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/20/2015 19:39'!
nextPrimaryExpression
	inputStream skipSeparators.
	(self peekForVariableReference
		or: [self peekForParenthesizedExpression
			or: [self peekForStringLiteral
				or: [self peekForNumber]]])
		ifFalse: [self nextFunctionCall].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 11:46'!
nextRelationalExpression
	handler handleStartRelationalExpression.
	self nextAdditiveExpression.
	[self peekForRelationalOperator]
		whileTrue: [self nextAdditiveExpression].
	handler handleEndRelationalExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 22:10'!
nextUnaryExpression
	| totalNegations |

	handler handleStartUnaryExpression.
	totalNegations := 0.
	[self peekForNegationOperator]
		whileTrue: [totalNegations := totalNegations + 1].
	totalNegations odd
		ifTrue: [handler handleNegation].
	self nextUnionExpression.
	handler handleEndUnaryExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 11:07'!
nextUnionExpression
	handler handleStartUnionExpression.
	self nextPathExpression.
	[self peekForUnion]
		whileTrue: [self nextPathExpression].
	handler handleEndUnionExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:24'!
parseInput
	currentAxis := XPathAxis new.
	nodeTestParser :=
		XPathNodeTestParser
			on: inputStream
			for:
				(XPathExpressionNodeTestParserHandler
					currentAxis: currentAxis
					expressionParserHandler: handler).
	self nextOrExpression.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 22:11'!
peekFailedAt: aPosition
	inputStream position: aPosition.
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/15/2015 04:00'!
peekForAbbreviatedAxis
	| nextChar |

	((nextChar := inputStream peek) notNil
		and: [AbbreviatedAxisSpecifierCharacters includes: nextChar])
		ifFalse: [^ false].
	writeStream
		reset;
		nextPut: inputStream next.
	[(nextChar := inputStream peek) notNil
		and: [AbbreviatedAxisSpecifierCharacters includes: nextChar]]
		whileTrue: [writeStream nextPut: inputStream next].
	currentAxis axisSpecifier: writeStream contents.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/16/2015 14:13'!
peekForAbbreviatedDescendantStep
	(inputStream peekFor: $/)
		ifFalse: [^ false].

	"// followed by a node test is the same as
	descendant:: followed by the node test"
	currentAxis axisSpecifier: 'descendant'.
	nodeTestParser parse
		ifTrue: [self peekForPredicates]
		ifFalse: [
			"// followed by an abbreviated step or step with an
			explicit axis is the same as descendant-or-self::node()/
			followed by the step"
			currentAxis axisSpecifier: 'descendant-or-self'.
			self startNodeTestForAnyNodeType.
			self peekForStep
				ifFalse: [self errorExpectedStep]].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/16/2015 14:36'!
peekForAbbreviatedStep
	(inputStream peekFor: $.)
		ifFalse: [^ false].
	self atDigit "float literal"
		ifTrue: [
			inputStream skipBack.
			^ false].

	(inputStream peekFor: $.)
		ifTrue: [currentAxis axisSpecifier: 'parent']
		ifFalse: [
			currentAxis isFirstAxis
				ifFalse: [
					"can be omitted"
					currentAxis resetToImplicitAxis.
					^ true].
			currentAxis axisSpecifier: 'self'].
	self startNodeTestForAnyNodeType.

	"abbreviated steps cannot have filters"
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/16/2015 14:34'!
peekForAbsoluteLocationPath
	self peekForLocationPathSeparator
		ifFalse: [^ false].

	handler handleStartAbsoluteLocationPath.
	currentAxis
		resetToImplicitAxis;
		beFirstAxis.
	self peekForAdditionalSteps
		ifFalse: [
			currentAxis axisSpecifier: 'self'.
			self startNodeTestForAnyNodeType].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/16/2015 05:34'!
peekForAdditionalSteps
	(self peekForAbbreviatedDescendantStep
		or: [self peekForStep])
		ifFalse: [^ false].
	[self peekForLocationPathSeparator]
		whileTrue: [
			(self peekForAbbreviatedDescendantStep
				or: [self peekForStep])
				ifFalse: [self errorExpectedStep]].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/12/2015 05:10'!
peekForAdditiveOperator
	inputStream skipSeparators.
	(inputStream peekFor: $+)
		ifTrue: [
			handler handleAddition.
			^ true].
	(inputStream peekFor: $-)
		ifTrue: [
			handler handleSubtraction.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:35'!
peekForAndOperator
	inputStream skipSeparators.
	^ inputStream peekForAll: 'and'.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/2/2015 04:38'!
peekForAttributePredicate
	| startPosition namePosition ncName isNotEquals stringLiteral |

	startPosition := inputStream position.
	(inputStream peekFor: $@)
		ifFalse: [^ false].

	inputStream skipSeparators.
	namePosition := inputStream position.
	(ncName := self nextNCNameOptional: true)
		ifNil: [^ self peekFailedAt: startPosition].

	inputStream skipSeparators.
	isNotEquals := inputStream peekFor: $!!.
	(inputStream peekFor: $=)
		ifTrue: [
			inputStream skipSeparators.
			((stringLiteral := self nextStringLiteralOptional: true) notNil
				and: [self peekForEndPredicate])
				ifTrue: [
					isNotEquals
						ifTrue: [
							handler
								handlePredicateAttribute: ncName
								notEqualsStringLiteral: stringLiteral]
						ifFalse: [
							handler
								handlePredicateAttribute: ncName
								equalsStringLiteral: stringLiteral].
					^ true]].
	inputStream
		pushBackNCName: ncName
		position: namePosition.
	^ self peekFailedAt: startPosition.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/26/2015 14:58'!
peekForAxis
	| startPosition ncName |

	self peekForAbbreviatedAxis
		ifTrue: [^ true].
	startPosition := inputStream position.
	(ncName := self nextNCNameOptional: true)
		ifNil: [^ false].
	inputStream skipSeparators.
	((inputStream peekFor: $:)
		and: [inputStream peekFor: $:])
		ifFalse: [
			inputStream
				pushBackNCName: ncName
				position: startPosition.
			^ false].
	currentAxis axisSpecifier: ncName.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/20/2015 11:12'!
peekForEndPredicate
	inputStream skipSeparators.
	^ inputStream peekFor: $].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/13/2015 11:45'!
peekForEqualityOperator
	inputStream skipSeparators.
	(inputStream peekForAll: '!!=')
		ifTrue: [
			handler handleNotEquals.
			^ true].
	(inputStream peekFor: $=)
		ifTrue: [
			handler handleEquals.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:33'!
peekForIntegerPredicate
	| startPosition |

	self atDigit
		ifFalse: [^ false].
	
	startPosition := inputStream position.
	writeStream reset.
	self nextDigitsOnWriteStream.
	self peekForEndPredicate
		ifTrue: [
			handler handleIntegerPredicate: writeStream contents.
			^ true]
		ifFalse: [^ self peekFailedAt: startPosition].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/22/2015 22:21'!
peekForLocationPathExpression
	^ self peekForAbsoluteLocationPath
		or: [self peekForRelativeLocationPath]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/14/2015 02:43'!
peekForLocationPathSeparator
	inputStream skipSeparators.
	^ inputStream peekFor: $/.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:43'!
peekForMultiplicativeOperator
	inputStream skipSeparators.
	inputStream atEnd
		ifTrue: [^ false].
	(inputStream peekFor: $*)
		ifTrue: [
			handler handleMultiplication.
			^ true].
	(inputStream peekForAll: 'div')
		ifTrue: [
			handler handleDivision.
			^ true].
	(inputStream peekForAll: 'mod')
		ifTrue: [
			handler handleModulus.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:45'!
peekForNegationOperator
	inputStream skipSeparators.
	^ inputStream peekFor: $-.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 6/17/2015 00:55'!
peekForNumber
	| startPosition |

	startPosition := inputStream position.
	writeStream reset.
	self atDigit
		ifTrue: [
			self nextDigitsOnWriteStream.
			(inputStream peekFor: $.)
				ifTrue: [
					"Smalltalk float literals can't have a trailing '.'"
					self atDigit
						ifTrue: [
							writeStream nextPut: $..
							self nextDigitsOnWriteStream]].
			handler handleNumberLiteral: writeStream contents.
			^ true].
	(inputStream peekFor: $.)
		ifTrue: [
			self atDigit
				ifTrue: [
					"Smalltalk float literals can't have a trailing '.'"
					writeStream nextPutAll: '0.'.
					self nextDigitsOnWriteStream.
					handler handleNumberLiteral: writeStream contents.
					^ true]].
	^ self peekFailedAt: startPosition.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:35'!
peekForOrOperator
	inputStream skipSeparators.
	^ inputStream peekForAll: 'or'.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:41'!
peekForParenthesizedExpression
	(inputStream peekFor: $()
		ifFalse: [^ false].

	self nextOrExpression.
	inputStream skipSeparators.
	self expectNext: $).
	^ true.
! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/2/2015 07:17'!
peekForPredicate
	self peekForStartPredicate
		ifFalse: [^ false].

	inputStream skipSeparators.
	(self peekForIntegerPredicate
		or: [self peekForAttributePredicate])
		ifFalse: [
			handler handleStartPredicate.
			self nextOrExpression.
			self peekForEndPredicate
				ifFalse: [self errorExpectedEndPredicate].
			handler handleEndPredicate].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/2/2015 07:12'!
peekForPredicates
	self peekForPredicate
		ifTrue: [
			[self peekForPredicate] whileTrue.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/13/2015 11:48'!
peekForRelationalOperator
	inputStream skipSeparators.
	(inputStream peekFor: $<)
		ifTrue: [
			(inputStream peekFor: $=)
				ifTrue: [handler handleLessThanOrEqualTo]
				ifFalse: [handler handleLessThan].
			^ true].
	(inputStream peekFor: $>)
		ifTrue: [
			(inputStream peekFor: $=)
				ifTrue: [handler handleGreaterThanOrEqualTo]
				ifFalse: [handler handleGreaterThan].
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/16/2015 12:46'!
peekForRelativeLocationPath
	currentAxis
		resetToImplicitAxis;
		beFirstAxis;
		beStartOfRelativeLocationPath.
	self peekForStep
		ifFalse: [^ false].
	self peekForLocationPathSeparator
		ifTrue: [self nextAdditionalSteps].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/2/2015 07:15'!
peekForStartPredicate
	inputStream skipSeparators.
	^ inputStream peekFor: $[.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/16/2015 14:16'!
peekForStep
	inputStream skipSeparators.
	inputStream atEnd
		ifTrue: [^ false].

	self peekForAbbreviatedStep
		ifTrue: [^ true].

	self peekForAxis.
	nodeTestParser parse
		ifTrue: [
			self peekForPredicates.
			^ true]
		ifFalse: [
			currentAxis isImplicitAxis
				ifFalse: [self errorExpectedNodeTest].
			currentAxis resetToImplicitAxis.
			^ false].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/21/2015 07:12'!
peekForStringLiteral
	(self nextStringLiteralOptional: true)
		ifNil: [^ false]
		ifNotNil: [:string |
			handler handleStringLiteral: string.
			^ true]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:36'!
peekForUnion
	inputStream skipSeparators.
	(inputStream peekFor: $|)
		ifTrue: [
			handler handleUnion.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:36'!
peekForVariableReference
	(inputStream peekFor: $$)
		ifTrue: [
			handler handleVariableReference: self nextName.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 4/16/2015 14:13'!
startNodeTestForAnyNodeType
	currentAxis isStartOfRelativeLocationPath
		ifTrue: [handler handleStartRelativeLocationPath].
	handler
		handleAxis: currentAxis;
		handleTestForAnyNodeType.
	currentAxis resetToImplicitAxis.! !

XPathParser subclass: #XPathFunctionPrototypeParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathFunctionPrototypeParser commentStamp: 'monty 6/5/2015 01:09' prior: 0!
This class parses XPath function prototypes to extract the name, return type, and the number and type of arguments.!

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorArgumentAfterUnboundedArgument
	XPathSyntaxException signal: 'Argument after unbounded "*" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorNonOptionalArgumentAfterOptional
	XPathSyntaxException signal: 'Non-optional argument afer optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:23'!
errorUnboundedArgumentAfterOptional
	XPathSyntaxException signal: 'Unbounded "*" argument after optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:22'!
nextArgument
	handler hasUnboundedArgument
		ifTrue: [self errorArgumentAfterUnboundedArgument].

	inputStream skipSeparators.
	self nextModifierForArgument: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:38'!
nextFunctionName
	inputStream skipSeparators.
	handler handleFunctionName: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 4/8/2015 20:11'!
nextModifierForArgument: anArgument
	inputStream skipSeparators.
	(inputStream peekFor: $*)
		ifTrue: [
			handler hasOptionalArgument
				ifTrue: [self errorUnboundedArgumentAfterOptional].
			handler handleUnboundedArgument: anArgument]
		ifFalse: [
			(inputStream peekFor: $?)
				ifTrue: [handler handleOptionalArgument: anArgument]
				ifFalse: [
					handler hasOptionalArgument
						ifTrue: [self errorNonOptionalArgumentAfterOptional].
					handler handleArgument: anArgument]].! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:37'!
nextReturnType
	inputStream skipSeparators.
	handler handleReturnType: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:26'!
parseInput
	self
		nextReturnType;
		nextFunctionName;
		nextArgumentList! !

XPathParser subclass: #XPathNodeTestParser
	instanceVariableNames: 'context'
	classVariableNames: 'NodeTypeTestParserSelectors'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParser commentStamp: 'monty 2/10/2015 02:56' prior: 0!
This class parses node tests that are either node name tests like 'name' or '*' or node type tests like 'node()' or 'comment()'.!

!XPathNodeTestParser class methodsFor: 'class initialization' stamp: 'monty 2/22/2015 01:09'!
initialize 
	"self initialize"

	self initializeNodeTypeTestParserSelectors! !

XPathNodeTestParser initialize!

!XPathNodeTestParser class methodsFor: 'class initialization' stamp: 'monty 3/2/2015 14:50'!
initializeNodeTypeTestParserSelectors
	(NodeTypeTestParserSelectors := Dictionary new)
		at: 'comment' put: #nextCommentTypeTest;
		at: 'text' put: #nextTextTypeTest;
		at: 'processing-instruction' put: #nextPITypeTest;
		at: 'node' put: #nextAnyNodeTypeTest;
		at: 'element' put: #nextElementTypeTest;
		at: 'attribute' put: #nextAttributeTypeTest;
		at: 'namespace' put: #nextNamespaceTypeTest! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/1/2015 08:44'!
nextAnyNodeTypeTest
	self nextEndArgumentList.
	context handleTestForAnyNodeTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 4/10/2015 04:15'!
nextAttributeTypeTest
	context := XPathNodeTestParserAttributeTypeTestContext new.
	self
		peekForNodeTest;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 2/27/2015 13:46'!
nextCommentTypeTest
	self nextEndArgumentList.
	context handleTestForCommentTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 4/10/2015 04:15'!
nextElementTypeTest
	context := XPathNodeTestParserElementTypeTestContext new.
	self
		peekForNodeTest;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 2/22/2015 11:26'!
nextEmptyTest
	context handleEmptyTestWith: handler! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 4/14/2015 10:09'!
nextNamespaceTypeTest
	context := XPathNodeTestParserNamespaceTypeTestContext new.
	self
		peekForNodeTest;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/5/2015 08:15'!
nextPITypeTest
	| name |

	inputStream skipSeparators.
	name :=
		(self nextStringLiteralOptional: true)
			ifNil: [self nextNCNameOptional: true].
	name
		ifNil: [context handleTestForPITypeWith: handler]
		ifNotNil: [
			context
				handleTestForPIWithName: name
				with: handler].
	self nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 3/1/2015 11:11'!
nextTextTypeTest
	self nextEndArgumentList.
	context handleTestForTextTypeWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 4/11/2015 03:55'!
parseInput
	context := handler defaultNodeTestParserContextClass new.
	self peekForNodeTest.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/15/2015 07:33'!
peekForExpandedNameTest: aName
	(aName = 'Q'
		and: [inputStream peekFor: ${])
		ifTrue: [| uri |
			uri := self expectUpTo: $}.
			(inputStream peekFor: $*)
				ifTrue: [
					context
						handleTestForNamespaceURI: uri
						with: handler]
				ifFalse: [
					context
						handleTestForNamespaceURI: uri
						localName: self nextNCName
						with: handler].
			^ true]
		ifFalse: [^ false]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/11/2015 04:13'!
peekForNameTestOrNoteTypeTest: aLocalName
	inputStream skipSeparators.
	(inputStream peekFor: $:)
		ifTrue: [^ false]. ": after spaces; axis specifier"

	(context canHandleTypeTests
		and: [self peekForStartArgumentList])
		ifTrue: [^ self peekForNodeTypeTest: aLocalName]
		ifFalse: [
			context
				handleTestForName: aLocalName
				with: handler.
			^ true].! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/3/2015 17:39'!
peekForNameTestStartingWith: anNcName
	(inputStream peekFor: $:)
		ifTrue: [
			inputStream peek == $: ":: axis specifier"
				ifTrue: [^ false]
				ifFalse: [^ self peekForQualifiedNameTestWithPrefix: anNcName]]
		ifFalse: [
			^ (self peekForExpandedNameTest: anNcName)
				or: [self peekForNameTestOrNoteTypeTest: anNcName]]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 04:54'!
peekForNodeTest
	inputStream skipSeparators.
	(inputStream atEnd not
		and: [self peekForWildCardNameTest
			or: [self peekForNonWildCardNameTest]])
		ifTrue: [^ true]
		ifFalse: [
			self nextEmptyTest.
			^ false]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 03:56'!
peekForNodeTypeTest: aNodeTypeOrFunctionName
	self perform:
		(NodeTypeTestParserSelectors
			at: aNodeTypeOrFunctionName
			ifAbsent: [^ false]).
	^ true.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/28/2015 14:29'!
peekForNonWildCardNameTest
	| startPosition ncName |

	startPosition := inputStream position.
	((ncName := self nextNCNameOptional: true) notNil
		and: [self peekForNameTestStartingWith: ncName])
		ifTrue: [^ true]
		ifFalse: [
			ncName
				ifNotNil: [
					inputStream
						pushBackNCName: ncName
						position: startPosition].
			^ false].! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 11:42'!
peekForQualifiedNameTestWithPrefix: aPrefix
	(inputStream peekFor: $*)
		ifTrue: [
			context
				handleTestForPrefix: aPrefix
				with: handler.
			^ true]
		ifFalse: [| localName |
			localName := self nextNCName.
			self peekForStartArgumentList "function"
				ifTrue: [^ false]
				ifFalse: [
					context
						handleTestForPrefix: aPrefix
						localName: localName
						with: handler.
					^ true]].! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/27/2015 05:24'!
peekForStartArgumentList
	inputStream skipSeparators.
	^ inputStream peekFor: $(.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2015 11:46'!
peekForWildCardNameTest
	(inputStream peekFor: $*)
		ifFalse: [^ false].

	(inputStream peekFor: $:)
		ifTrue: [
			(inputStream peekFor: $*)
				ifTrue: [context handleTestForAnyNameWith: handler]
				ifFalse: [
					context
						handleTestForLocalName: self nextNCName
						with: handler]]
		ifFalse: [context handleTestForAnyNameWith: handler].
	^ true.! !

!XPathParser class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 06:01'!
on: aStringOrStream for: aHandler
	^ self new
		on: aStringOrStream
		for: aHandler! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:27'!
endParsing
	handler handleEndParsing.
	handler mustBeAtEndAfterParsing
		ifTrue: [	
			inputStream skipSeparators.
			inputStream atEnd
				ifFalse: [self errorExpectedAtEnd]].! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpected: aString
	XPathSyntaxException
		formatSignal: 'Expected {1}'
		with: aString! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:53'!
errorExpectedAtEnd
	self errorExpected: 'end of input'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpectedLiteral: anExpectedCharacterOrString butGot: aReceivedCharacterOrString
	XPathSyntaxException
		formatSignal: 'Expected "{1}" but got "{2}"'
		with: anExpectedCharacterOrString
		with: (aReceivedCharacterOrString ifNil: [''])! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/8/2015 05:57'!
errorExpectedName
	self errorExpected: 'name'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/8/2015 05:57'!
errorExpectedRelativeLocationPath
	self errorExpected: 'relative location path'! !

!XPathParser methodsFor: 'private' stamp: 'monty 3/10/2015 19:48'!
errorExpectedStringLiteral
	self errorExpected: 'single or double quoted string literal'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/18/2015 14:06'!
expectNext: aCharacter
	| nextChar |

	((nextChar := inputStream next) == aCharacter)
		ifFalse: [
			self
				errorExpectedLiteral: aCharacter
				butGot: nextChar].
	^ aCharacter.! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/10/2015 08:58'!
expectUpTo: aCharacter
	writeStream reset.
	[inputStream atEnd
		or: [inputStream peek == aCharacter]]
		whileFalse: [writeStream nextPut: inputStream next].
	self expectNext: aCharacter.
	^ writeStream contents.! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 1/8/2015 06:02'!
handler
	^ handler! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 1/8/2015 06:02'!
inputStream
	^ inputStream! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/15/2015 22:25'!
nextArgument
	"override to parse arguments in function argument lists"! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:26'!
nextArgumentList
	"a template method; nextArgument must be overriden to handle arguments"
	self nextStartArgumentList.
	self peekForEndArgumentList
		ifFalse: [
			self nextArgument.
			[self peekForArgumentSeparator]
				whileTrue: [self nextArgument].
			self nextEndArgumentList].! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:20'!
nextEmptyArgumentList
	self
		nextStartArgumentList;
		nextEndArgumentList
! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:19'!
nextEndArgumentList
	inputStream skipSeparators.
	self expectNext: $).! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 03:46'!
nextNCName
	^ self nextNCNameOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 4/1/2015 23:13'!
nextNCNameOptional: aBoolean
	(inputStream hasPushedBackToken
		and: [inputStream pushedBackToken isNCNameToken])
		ifTrue: [^ inputStream nextPushedBackToken]
		ifFalse: [
			writeStream reset.
			(XMLWellFormedParserTokenizer
				nextNCNameFrom: inputStream
				on: writeStream)
				ifFalse: [
					aBoolean
						ifTrue: [^ nil]
						ifFalse: [self errorExpectedName]].
			^ writeStream contents]! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/2/2015 04:40'!
nextName
	^ self nextNameOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 4/1/2015 23:12'!
nextNameOptional: aBoolean
	writeStream reset.
	(inputStream hasPushedBackToken
		and: [inputStream pushedBackToken isNCNameToken])
		ifTrue: [
			writeStream nextPutAll: inputStream nextPushedBackToken.
			(inputStream peekFor: $:)
				ifTrue: [
					writeStream
						nextPut: $:;
						nextPutAll: self nextNCName]]
		ifFalse: [
			(XMLWellFormedParserTokenizer
				nextNameFrom: inputStream
				on: writeStream)
				ifFalse: [
					aBoolean
						ifTrue: [^ nil]
						ifFalse: [self errorExpectedName]]].
	^ writeStream contents.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:19'!
nextStartArgumentList
	inputStream skipSeparators.
	self expectNext: $(.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 03:42'!
nextStringLiteral
	^ self nextStringLiteralOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:47'!
nextStringLiteralOptional: aBoolean
	(inputStream peek == $"
		or: [inputStream peek == $'])
		ifTrue: [^ self expectUpTo: inputStream next]
		ifFalse: [
			aBoolean
				ifFalse: [self errorExpectedStringLiteral].
			^ nil]! !

!XPathParser methodsFor: 'initialization' stamp: 'monty 1/14/2015 03:22'!
on: aStringOrStream for: aHandler
	inputStream :=
		(aStringOrStream isStream
			ifTrue: [aStringOrStream asXPathReadStreamAdapter]
			ifFalse: [aStringOrStream readStream asXPathReadStreamAdapter]).
	handler := aHandler.
	writeStream := (String new: 32) writeStream.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 4/12/2015 07:27'!
parse
	[self
		startParsing;
		parseInput;
		endParsing]
		on: XPathException
		do: [:error |
			error hasPosition
				ifFalse: [error position: inputStream position].
			error pass].
	^ handler parsingResult.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 06:06'!
parseInput
	self subclassResponsibility! !

!XPathParser methodsFor: 'parsing - peeking' stamp: 'monty 4/2/2015 07:10'!
peekForArgumentSeparator
	inputStream skipSeparators.
	^ inputStream peekFor: $,.! !

!XPathParser methodsFor: 'parsing - peeking' stamp: 'monty 4/2/2015 07:10'!
peekForEndArgumentList
	inputStream skipSeparators.
	^ inputStream peekFor: $).! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:59'!
startParsing
	handler handleStartParsing! !

Object subclass: #XPathParserHandler
	instanceVariableNames: 'parsingResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParserHandler commentStamp: 'monty 5/11/2015 00:46' prior: 0!
An abstract class for XPath parser handlers. Subclasses implement "handling" messages sent by parsers.!

XPathParserHandler subclass: #XPathExpressionParserHandler
	instanceVariableNames: 'outputStream variableIndex contextNodeVariable contextPositionVariable contextSizeVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParserHandler commentStamp: 'monty 2/10/2015 02:55' prior: 0!
A handler for XPath expression parsers that generates Smalltalk source implementing the XPath expression.!

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/12/2015 05:53'!
decrementVariableNames
	variableIndex := variableIndex - 1.
	self generateVariableNames.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitBooleanConversion
	outputStream nextPutAll: ' asXPathBoolean'! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/10/2015 22:14'!
emitEndAttributePredicate
	outputStream nextPutAll: ']]'.
	self emitEndPredicateBlock.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitEndBlock
	outputStream nextPut: $]! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitEndGrouping
	outputStream nextPut: $)! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:26'!
emitEndPredicateBlock
	self decrementVariableNames.
	outputStream nextPut: $].! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:15'!
emitQuotedString: aString
	outputStream nextPut: $'.
	"escape ' by outputting another ' before it"
	1 to: aString size do: [:i | | nextChar |
		(nextChar := aString at: i) == $'
			ifTrue: [outputStream nextPut: $'].
		outputStream nextPut: nextChar].
	outputStream nextPut: $'.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:34'!
emitStartAttributePredicate: aName
	self emitStartPredicateBlock.
	outputStream
		nextPutAll: contextNodeVariable;
		nextPutAll: ' isElement and:[';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' hasAttributes and:[(';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' attributeAt:'.
	self emitQuotedString: aName.
	outputStream nextPut: $).! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 3/26/2015 22:43'!
emitStartContextBlock
	outputStream
		nextPutAll: '[:';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' :c| |';
		nextPutAll: contextPositionVariable;
		space;
		nextPutAll: contextSizeVariable;
		nextPut: $|! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitStartGrouping
	outputStream nextPut: $(! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 3/26/2015 21:06'!
emitStartPredicateBlock
	self incrementVariableNames.
	outputStream
		nextPutAll: '??[:';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' :';
		nextPutAll: contextPositionVariable;
		nextPutAll: ' :';
		nextPutAll: contextSizeVariable;
		nextPut: $|.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 3/26/2015 21:09'!
generateVariableNames
	| indexString |

	indexString := variableIndex printString.
	contextNodeVariable := indexString copyWithFirst: $n.
	contextPositionVariable := indexString copyWithFirst: $p.
	contextSizeVariable := indexString copyWithFirst: $s.! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleAddition
	outputStream nextPutAll: '//+'! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 4/16/2015 12:41'!
handleAxis: anAxis
	outputStream nextPutAll: anAxis replacementSelector! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:52'!
handleDivision
	outputStream nextPutAll: '///'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:21'!
handleEndAdditiveExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:47'!
handleEndAndExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:55'!
handleEndEqualityExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/14/2015 04:58'!
handleEndFunctionArgument
	outputStream nextPutAll: ');'! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/14/2015 04:57'!
handleEndFunctionCall
	outputStream nextPutAll: 'invoke)'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:55'!
handleEndMultiplicativeExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:27'!
handleEndOrExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/11/2015 10:05'!
handleEndParsing
	self
		emitEndBlock;
		parsingResult: outputStream contents! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/13/2015 11:23'!
handleEndPathExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:26'!
handleEndPredicate
	self emitEndPredicateBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:47'!
handleEndRelationalExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:05'!
handleEndShortCircuitAnd
	self
		emitBooleanConversion;
		emitEndBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:05'!
handleEndShortCircuitOr
	self
		emitBooleanConversion;
		emitEndBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/11/2015 00:11'!
handleEndShortCircuited: anInteger
	anInteger > 0
		ifTrue: [
			self emitBooleanConversion.
			anInteger timesRepeat: [self emitEndBlock]]! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/14/2015 03:54'!
handleEndUnaryExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:08'!
handleEndUnionExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleEquals
	outputStream nextPutAll: '//='! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleGreaterThan
	outputStream nextPutAll: '//>'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleGreaterThanOrEqualTo
	outputStream nextPutAll: '//>='! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 3/26/2015 22:33'!
handleIntegerPredicate: anIntegerString
	outputStream
		nextPutAll: '??';
		nextPutAll: anIntegerString! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 4/2/2015 08:57'!
handleLastFunctionCall
	outputStream
		nextPut: $(;
		nextPutAll: contextSizeVariable;
		nextPutAll: ' ifNil:[1])'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:09'!
handleLessThan
	outputStream nextPutAll: '//<'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:11'!
handleLessThanOrEqualTo
	outputStream nextPutAll: '//<='! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:11'!
handleModulus
	outputStream nextPutAll: '//\\'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:11'!
handleMultiplication
	outputStream nextPutAll: '//*'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:10'!
handleNegation
	outputStream nextPutAll: '-1//*'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:10'!
handleNotEquals
	outputStream nextPutAll: '//!!='! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/11/2015 12:13'!
handleNumberLiteral: anIntegerOrFloatString
	outputStream
		space;
		nextPutAll: anIntegerOrFloatString! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 4/2/2015 08:57'!
handlePositionFunctionCall
	outputStream
		nextPut: $(;
		nextPutAll: contextPositionVariable;
		nextPutAll: ' ifNil:[1])'! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:33'!
handlePredicateAttribute: aName equalsStringLiteral: aStringLiteral
	self emitStartAttributePredicate: aName.
	outputStream nextPut: $=.
	self
		emitQuotedString: aStringLiteral;
		emitEndAttributePredicate.! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:33'!
handlePredicateAttribute: aName notEqualsStringLiteral: aStringLiteral
	self emitStartAttributePredicate: aName.
	outputStream nextPutAll: '~='.
	self
		emitQuotedString: aStringLiteral;
		emitEndAttributePredicate.! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/4/2015 06:45'!
handleStartAbsoluteLocationPath
	outputStream
		nextPutAll: contextNodeVariable;
		nextPutAll: ' documentRoot'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:21'!
handleStartAdditiveExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:47'!
handleStartAndExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:45'!
handleStartEqualityExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/14/2015 04:58'!
handleStartFunctionArgument
	outputStream nextPutAll: 'push: ('! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/12/2015 06:01'!
handleStartFunctionCall: aFunctionName
	outputStream
		nextPutAll: '((c function: ''';
		nextPutAll: aFunctionName;
		nextPutAll: ''' contextNode: ';
		nextPutAll: contextNodeVariable;
		nextPut: $)! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:04'!
handleStartMultiplicativeExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:27'!
handleStartOrExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/12/2015 05:56'!
handleStartParsing
	outputStream := (String new: 128) writeStream.
	variableIndex := 1.
	self
		generateVariableNames;
		emitStartContextBlock.! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/13/2015 11:23'!
handleStartPathExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:25'!
handleStartPredicate
	self emitStartPredicateBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:47'!
handleStartRelationalExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/14/2015 02:44'!
handleStartRelativeLocationPath
	outputStream nextPutAll: contextNodeVariable! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:16'!
handleStartShortCircuitAnd
	self emitBooleanConversion.
	outputStream nextPutAll: ' and:['.! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:16'!
handleStartShortCircuitOr
	self emitBooleanConversion.
	outputStream nextPutAll: ' or:['.! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/14/2015 03:54'!
handleStartUnaryExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:08'!
handleStartUnionExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/20/2015 11:15'!
handleStringLiteral: aString
	self emitQuotedString: aString! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 3/1/2015 13:10'!
handleSubtraction
	outputStream nextPutAll: '//-'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType
	outputStream nextPutAll: '[:n|true]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName
	outputStream nextPutAll: '[:n|n isAttribute]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 13:55'!
handleTestForAttributeWithLocalName: aLocalName
	outputStream
		nextPutAll: '[:n|n isAttribute and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 14:04'!
handleTestForAttributeWithName: aName
	outputStream
		nextPutAll: '[:n|n isAttribute and:[n name=''';
		nextPutAll: aName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/15/2015 07:36'!
handleTestForAttributeWithNamespaceURI: aURI
	outputStream
		nextPutAll: '[:n|n isAttribute and:[n namespaceURI=''';
		nextPutAll: aURI;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName
	outputStream
		nextPutAll: '[:n|n isAttribute and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: '''and:[n namespaceURI=''';
		nextPutAll: aURI;
		nextPutAll: ''']]]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 16:05'!
handleTestForAttributeWithPrefix: aPrefix
	outputStream
		nextPutAll: '(c testForAttributeWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/2/2015 13:35'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName
	outputStream
		nextPutAll: '(c testForAttributeWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: '''localName:''';
		nextPutAll: aLocalName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType
	outputStream nextPutAll: '[:n|n isComment]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName
	outputStream nextPutAll: '[:n|n isElement]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 16:11'!
handleTestForElementWithLocalName: aLocalName
	outputStream
		nextPutAll: '[:n|n isElement and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 16:10'!
handleTestForElementWithName: aName
	outputStream
		nextPutAll: '[:n|n isElement and:[n name=''';
		nextPutAll: aName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/15/2015 07:37'!
handleTestForElementWithNamespaceURI: aURI
	outputStream
		nextPutAll: '[:n|n isElement and:[n namespaceURI=''';
		nextPutAll: aURI;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/22/2015 02:52'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName
	outputStream
		nextPutAll: '[:n|n isElement and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: '''and:[n namespaceURI=''';
		nextPutAll: aURI;
		nextPutAll: ''']]]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 16:05'!
handleTestForElementWithPrefix: aPrefix
	outputStream
		nextPutAll: '(c testForElementWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/2/2015 13:35'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName
	outputStream
		nextPutAll: '(c testForElementWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: '''localName:''';
		nextPutAll: aLocalName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/10/2015 02:42'!
handleTestForNamespaceWithAnyName
	outputStream nextPutAll: '[:n|n isNamespace]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/10/2015 02:45'!
handleTestForNamespaceWithLocalName: aLocalName
	outputStream
		nextPutAll: '[:n|n isNamespace and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/10/2015 02:46'!
handleTestForNamespaceWithName: aName
	outputStream
		nextPutAll: '[:n|n isNamespace and:[n name=''';
		nextPutAll: aName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/15/2015 07:37'!
handleTestForNamespaceWithNamespaceURI: aURI
	outputStream
		nextPutAll: '[:n|n isNamespace and:[n namespaceURI=''';
		nextPutAll: aURI;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/10/2015 02:52'!
handleTestForNamespaceWithNamespaceURI: aURI localName: aLocalName
	outputStream
		nextPutAll: '[:n|n isNamespace and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: '''and:[n namespaceURI=''';
		nextPutAll: aURI;
		nextPutAll: ''']]]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/10/2015 02:48'!
handleTestForNamespaceWithPrefix: aPrefix
	outputStream
		nextPutAll: '(c testForNamespaceWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/10/2015 02:49'!
handleTestForNamespaceWithPrefix: aPrefix localName: aLocalName
	outputStream
		nextPutAll: '(c testForNamespaceWithPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: '''localName:''';
		nextPutAll: aLocalName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 4/10/2015 02:41'!
handleTestForPIWithAnyName
	outputStream nextPutAll: '[:n|n isPI]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName
	outputStream
		nextPutAll: '[:n|n isPI and:[n target=''';
		nextPutAll: aName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType
	outputStream nextPutAll: '[:n|n isStringNode]'! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/13/2015 11:06'!
handleUnion
	outputStream nextPut: $|! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/17/2015 04:50'!
handleVariableReference: aName
	outputStream
		nextPutAll: '(c variableAt: ''';
		nextPutAll: aName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/12/2015 05:52'!
incrementVariableNames
	variableIndex := variableIndex + 1.
	self generateVariableNames.! !

XPathParserHandler subclass: #XPathFunctionPrototypeParserHandler
	instanceVariableNames: 'function returnType functionName minArguments maxArguments argumentTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

XPathFunctionPrototypeParserHandler class
	instanceVariableNames: 'classesByTypeName'!

!XPathFunctionPrototypeParserHandler commentStamp: 'monty 2/10/2015 20:39' prior: 0!
A handler for function prototype parsers that initializes an XPathFunction class with the function name, return type, and number and types of arguments specified by the prototype.!

XPathFunctionPrototypeParserHandler class
	instanceVariableNames: 'classesByTypeName'!

!XPathFunctionPrototypeParserHandler class methodsFor: 'private' stamp: 'monty 1/23/2015 19:48'!
classesByTypeName
	^ classesByTypeName
		ifNil: [
			(classesByTypeName := Dictionary new)
				at: 'object' put: Object;
				at: 'boolean' put: Boolean;
				at: 'string' put: String;
				at: 'number' put: Number;
				at: 'node-set' put: XPathNodeSet;
				yourself]! !

!XPathFunctionPrototypeParserHandler class methodsFor: 'private' stamp: 'monty 1/23/2015 19:47'!
classesByTypeNameAt: aTypeName ifAbsent: aBlock
	^ self classesByTypeName
		at: aTypeName
		ifAbsent: aBlock! !

!XPathFunctionPrototypeParserHandler class methodsFor: 'instance creation' stamp: 'monty 1/9/2015 07:12'!
function: aFunction
	^ self new setFunction: aFunction! !

!XPathFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/9/2015 07:34'!
addArgumentTypeFor: aTypeName
	argumentTypes addLast: (self classForTypeName: aTypeName)! !

!XPathFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/23/2015 12:42'!
classForTypeName: aTypeName
	^ self class
		classesByTypeNameAt: aTypeName
		ifAbsent: [self errorUnrecognizedTypeName: aTypeName]! !

!XPathFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/9/2015 07:14'!
errorUnrecognizedTypeName: aTypeName
	XPathTypeException
		formatSignal: 'Unrecognized type name "{1}"'
		with: aTypeName! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleArgument: anArgument
	minArguments := minArguments + 1.
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:19'!
handleEndParsing
	function
		setReturnType: returnType
		functionName: functionName
		minArguments: minArguments
		maxArguments: maxArguments
		argumentTypes: argumentTypes! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:17'!
handleFunctionName: aName
	functionName := aName! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleOptionalArgument: anArgument
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:15'!
handleReturnType: aReturnType
	returnType := self classForTypeName: aReturnType! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:32'!
handleUnboundedArgument: anArgument
	maxArguments := nil.
	self addArgumentTypeFor: anArgument.! !

!XPathFunctionPrototypeParserHandler methodsFor: 'testing' stamp: 'monty 1/9/2015 07:26'!
hasOptionalArgument
	^ minArguments < maxArguments
	! !

!XPathFunctionPrototypeParserHandler methodsFor: 'testing' stamp: 'monty 1/9/2015 07:27'!
hasUnboundedArgument
	^ maxArguments isNil! !

!XPathFunctionPrototypeParserHandler methodsFor: 'initialization' stamp: 'monty 1/9/2015 07:11'!
setFunction: aFunction
	function := aFunction.
	maxArguments := 0.
	minArguments := 0.
	argumentTypes := OrderedCollection new.! !

XPathParserHandler subclass: #XPathNodeTestParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserHandler commentStamp: 'monty 1/10/2015 01:22' prior: 0!
An abstract handler for node test parsers.!

XPathNodeTestParserHandler subclass: #XPathExpressionNodeTestParserHandler
	instanceVariableNames: 'currentAxis expressionParserHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionNodeTestParserHandler commentStamp: 'monty 2/10/2015 20:39' prior: 0!
A handler used by the expression parser for parsing node tests that are part of location path steps.!

!XPathExpressionNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 1/13/2015 11:43'!
currentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	^ self new
		setCurrentAxis: anAxis
		expressionParserHandler: anExpressionParserHandler! !

!XPathExpressionNodeTestParserHandler methodsFor: 'accessing' stamp: 'monty 4/11/2015 03:55'!
defaultNodeTestParserContextClass
	^ currentAxis defaultNodeTestParserContextClass! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/21/2015 18:30'!
handleEmptyTest
	self parsingResult: false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/13/2015 12:42'!
handleStartParsing
	self parsingResult: false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType
	self startNodeTest.
	expressionParserHandler handleTestForAnyNodeType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithAnyName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:00'!
handleTestForAttributeWithLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:51'!
handleTestForAttributeWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForAttributeWithNamespaceURI: aURI
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithNamespaceURI: aURI.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForAttributeWithNamespaceURI: aURI
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:52'!
handleTestForAttributeWithPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForAttributeWithPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:50'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForAttributeWithPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType
	self startNodeTest.
	expressionParserHandler handleTestForCommentType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForElementWithAnyName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:42'!
handleTestForElementWithLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForElementWithLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:42'!
handleTestForElementWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForElementWithName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForElementWithNamespaceURI: aURI
	self startNodeTest.
	expressionParserHandler handleTestForElementWithNamespaceURI: aURI.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:52'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForElementWithNamespaceURI: aURI
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:43'!
handleTestForElementWithPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForElementWithPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/3/2015 16:43'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForElementWithPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:42'!
handleTestForNamespaceWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithAnyName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:44'!
handleTestForNamespaceWithLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:46'!
handleTestForNamespaceWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:36'!
handleTestForNamespaceWithNamespaceURI: aURI
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithNamespaceURI: aURI.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:52'!
handleTestForNamespaceWithNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForNamespaceWithNamespaceURI: aURI
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:48'!
handleTestForNamespaceWithPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForNamespaceWithPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:50'!
handleTestForNamespaceWithPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForNamespaceWithPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:41'!
handleTestForPIWithAnyName
	self startNodeTest.
	expressionParserHandler handleTestForPIWithAnyName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName
	self startNodeTest.
	expressionParserHandler handleTestForPIWithName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType
	self startNodeTest.
	expressionParserHandler handleTestForTextType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'initialization' stamp: 'monty 1/13/2015 11:43'!
setCurrentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	currentAxis := anAxis.
	expressionParserHandler := anExpressionParserHandler.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'private' stamp: 'monty 4/16/2015 12:45'!
startNodeTest
	self parsingResult: true.
	currentAxis isStartOfRelativeLocationPath
		ifTrue: [expressionParserHandler handleStartRelativeLocationPath].
	expressionParserHandler handleAxis: currentAxis.
	currentAxis resetToImplicitAxis.! !

!XPathNodeTestParserHandler methodsFor: 'accessing' stamp: 'monty 4/11/2015 03:55'!
defaultNodeTestParserContextClass
	self subclassResponsibility! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:51'!
handleEmptyTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:59'!
handleTestForAttributeWithLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:19'!
handleTestForAttributeWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForAttributeWithNamespaceURI: aURI! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:19'!
handleTestForAttributeWithPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForElementWithNamespaceURI: aURI! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:42'!
handleTestForNamespaceWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:44'!
handleTestForNamespaceWithLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:46'!
handleTestForNamespaceWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:34'!
handleTestForNamespaceWithNamespaceURI: aURI! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:52'!
handleTestForNamespaceWithNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:48'!
handleTestForNamespaceWithPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:49'!
handleTestForNamespaceWithPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:41'!
handleTestForPIWithAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType! !

XPathNodeTestParserHandler subclass: #XPathStringNodeTestParserHandler
	instanceVariableNames: 'defaultNodeTestParserContextClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathStringNodeTestParserHandler commentStamp: 'monty 2/10/2015 02:54' prior: 0!
A handler for node tests that occur in string arguments to the abbreviated axis selectors. It converts them to node test blocks.!

!XPathStringNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 4/11/2015 03:55'!
defaultNodeTestParserContextClass: aClass
	^ self new defaultNodeTestParserContextClass: aClass! !

!XPathStringNodeTestParserHandler methodsFor: 'accessing' stamp: 'monty 4/11/2015 03:56'!
defaultNodeTestParserContextClass
	^ defaultNodeTestParserContextClass! !

!XPathStringNodeTestParserHandler methodsFor: 'accessing' stamp: 'monty 4/11/2015 03:56'!
defaultNodeTestParserContextClass: aClass
	defaultNodeTestParserContextClass := aClass! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/17/2015 08:16'!
handleEmptyTest
	XPathSyntaxException signal: 'String arguments to axis selectors must contain node tests'! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 08:44'!
handleTestForAnyNodeType
	self parsingResult: [:node | true]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:56'!
handleTestForAttributeWithAnyName
	self parsingResult: [:node | node isAttribute]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:00'!
handleTestForAttributeWithLocalName: aLocalName
	self parsingResult:
		[:node |
			node isAttribute
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:20'!
handleTestForAttributeWithName: aName
	self parsingResult:
		[:node |
			node isAttribute
				and: [node name = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:35'!
handleTestForAttributeWithNamespaceURI: aURI
	self parsingResult:
		[:node |
			node isAttribute
				and: [node namespaceURI = aURI]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:51'!
handleTestForAttributeWithNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		[:node |
			node isAttribute
				and: [node localName = aLocalName
					and: [node namespaceURI = aURI]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:18'!
handleTestForAttributeWithPrefix: aPrefix
	self parsingResult:
		[:node |
			node isAttribute
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForAttributeWithPrefix: aPrefix localName: aLocalName
	| name |

	name := aLocalName qualifyWithPrefix: aPrefix.	
	self parsingResult:
		[:node |
			node isAttribute
				and: [node name = name]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/27/2015 13:56'!
handleTestForCommentType
	self parsingResult: [:node | node isComment]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:22'!
handleTestForElementWithAnyName
	self parsingResult: [:node | node isElement]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithLocalName: aLocalName
	self parsingResult:
		[:node |
			node isElement
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:24'!
handleTestForElementWithName: aName
	self parsingResult:
		[:node |
			node isElement
				and: [node name = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:35'!
handleTestForElementWithNamespaceURI: aURI
	self parsingResult:
		[:node |
			node isElement
				and: [node namespaceURI = aURI]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/22/2015 02:52'!
handleTestForElementWithNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		[:node |
			node isElement
				and: [node localName = aLocalName
					and: [node namespaceURI = aURI]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix
	self parsingResult:
		[:node |
			node isElement
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 13:25'!
handleTestForElementWithPrefix: aPrefix localName: aLocalName
	| name |

	name := aLocalName qualifyWithPrefix: aPrefix.	
	self parsingResult:
		[:node |
			node isElement
				and: [node name = name]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:42'!
handleTestForNamespaceWithAnyName
	self parsingResult: [:node | node isNamespace]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:44'!
handleTestForNamespaceWithLocalName: aLocalName
	self parsingResult:
		[:node |
			node isNamespace
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:46'!
handleTestForNamespaceWithName: aName
	self parsingResult:
		[:node |
			node isNamespace
				and: [node name = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/15/2015 07:35'!
handleTestForNamespaceWithNamespaceURI: aURI
	self parsingResult:
		[:node |
			node isNamespace
				and: [node namespaceURI = aURI]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:52'!
handleTestForNamespaceWithNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		[:node |
			node isNamespace
				and: [node localName = aLocalName
					and: [node namespaceURI = aURI]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:48'!
handleTestForNamespaceWithPrefix: aPrefix
	self parsingResult:
		[:node |
			node isNamespace
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:50'!
handleTestForNamespaceWithPrefix: aPrefix localName: aLocalName
	| name |

	name := aLocalName qualifyWithPrefix: aPrefix.	
	self parsingResult:
		[:node |
			node isNamespace
				and: [node name = name]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 4/10/2015 02:41'!
handleTestForPIWithAnyName
	self parsingResult: [:node | node isPI]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 12:02'!
handleTestForPIWithName: aName
	self parsingResult:
		[:node |
			node isPI
				and: [node target = aName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2015 11:11'!
handleTestForTextType
	self parsingResult: [:node | node isStringNode]! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleEndParsing! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleStartParsing! !

!XPathParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ true! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 1/10/2015 06:10'!
parsingResult
	^ parsingResult! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 3/14/2015 14:00'!
parsingResult: aParsingResult
	"set value to be returned by #parse"

	parsingResult := aParsingResult! !

Object subclass: #XPathPushedBackToken
	instanceVariableNames: 'token position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackToken commentStamp: 'monty 1/15/2015 11:06' prior: 0!
This is a class for storing pushed-back tokens so they can be quickly read again.!

XPathPushedBackToken subclass: #XPathPushedBackNCNameToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackNCNameToken commentStamp: 'monty 1/10/2015 01:22' prior: 0!
A pushed-back non-qualified name token, to be read by nextNCName.!

!XPathPushedBackNCNameToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:21'!
isNCNameToken
	^ true! !

!XPathPushedBackToken class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 07:21'!
token: aToken position: aPosition
	^ self new
		setToken: aToken
		position: aPosition! !

!XPathPushedBackToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:19'!
isNCNameToken
	^ false! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 1/9/2015 08:18'!
position
	^ position! !

!XPathPushedBackToken methodsFor: 'initialization' stamp: 'monty 1/8/2015 07:22'!
setToken: aToken position: aPosition
	token := aToken.
	position := aPosition.! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 1/14/2015 15:07'!
token
	^ token! !

Object subclass: #XPathReadStreamAdapter
	instanceVariableNames: 'stream pushedBackToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathReadStreamAdapter commentStamp: 'monty 3/27/2015 21:44' prior: 0!
This class is an adapter for positionable read streams that wraps them to be safe to send messages like next and peek when atEnd and supports efficient push back of token objects to minimize backtracking by parsers.!

!XPathReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 4/7/2015 09:12'!
on: aPositionableStream
	^ self new on: aPositionableStream! !

!XPathReadStreamAdapter methodsFor: 'converting' stamp: 'monty 1/14/2015 03:19'!
asXPathReadStreamAdapter
	^ self! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/8/2015 02:50'!
atEnd
	^ stream atEnd! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/9/2015 08:02'!
hasPushedBackToken
	^ pushedBackToken notNil
		and: [pushedBackToken position = self position]! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/10/2015 01:20'!
isStream
	^ true! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:11'!
next
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream next]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/10/2015 02:29'!
nextPushedBackToken
	| token |

	token := pushedBackToken token.
	self position: self position + token size.
	pushedBackToken := nil.
	^ token.! !

!XPathReadStreamAdapter methodsFor: 'initialization' stamp: 'monty 1/8/2015 02:52'!
on: aStream
	stream := aStream! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:11'!
peek
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream peek]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/10/2015 02:29'!
peekFor: aCharacter
	(stream atEnd not
		and: [stream peek == aCharacter])
		ifTrue: [
			stream next.
			^ true]
		ifFalse: [^ false]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:10'!
peekForAll: aString
	| oldPosition |

	(stream atEnd not
		and: [stream peek == (aString at: 1)])
		ifFalse: [^ false].

	oldPosition := stream position.
	stream next.
	2 to: aString size do: [:i |
		(stream atEnd not
			and: [stream next == (aString at: i)])
			ifFalse: [
				stream position: oldPosition.
				^ false]].
	^ true.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 02:50'!
position
	^ stream position! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 02:50'!
position: aPosition
	stream position: aPosition! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/26/2015 14:34'!
pushBackNCName: anNcName position: aPosition
	self pushBackToken:
		(XPathPushedBackNCNameToken
			token: anNcName
			position: aPosition)! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/9/2015 11:33'!
pushBackToken: aPushedBackToken
	pushedBackToken := aPushedBackToken.
	self position: aPushedBackToken position.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/9/2015 08:03'!
pushedBackToken
	^ pushedBackToken! !

!XPathReadStreamAdapter methodsFor: 'streaming' stamp: 'monty 1/19/2015 13:51'!
skipBack
	"does not peek like #back"
	stream position: stream position - 1! !

!XPathReadStreamAdapter methodsFor: 'streaming' stamp: 'monty 4/7/2015 09:13'!
skipSeparators
	stream xPathSkipSeparators! !

Object subclass: #XPathReverseReadStream
	instanceVariableNames: 'collection position readLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathReverseReadStream commentStamp: 'monty 6/2/2015 05:37' prior: 0!
A basic read stream that streams a collection in reverse with next, peek, and atEnd.!

!XPathReverseReadStream class methodsFor: 'instance creation' stamp: 'monty 5/26/2015 23:37'!
on: aCollection
	^ self new on: aCollection! !

!XPathReverseReadStream methodsFor: 'testing' stamp: 'monty 5/26/2015 23:39'!
atEnd
	^ position >= readLimit! !

!XPathReverseReadStream methodsFor: 'testing' stamp: 'monty 5/26/2015 23:39'!
isStream
	^ true! !

!XPathReverseReadStream methodsFor: 'accessing' stamp: 'monty 5/28/2015 02:59'!
next
	self atEnd
		ifTrue: [^ nil]
		ifFalse: [| next |
			next := collection at: readLimit - position.
			position := position + 1.
			^ next]! !

!XPathReverseReadStream methodsFor: 'initialization' stamp: 'monty 5/26/2015 23:38'!
on: aCollection
	collection := aCollection.
	position := 0.
	readLimit := aCollection size.! !

!XPathReverseReadStream methodsFor: 'accessing' stamp: 'monty 5/28/2015 03:00'!
peek
	self atEnd
		ifTrue: [^ nil]
		ifFalse: [^ collection at: readLimit - position]! !

!XPathReverseReadStream methodsFor: 'accessing' stamp: 'monty 5/27/2015 23:04'!
position
	^ position! !

Object subclass: #XPathSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

XPathSortOrder class
	instanceVariableNames: 'instance'!

!XPathSortOrder commentStamp: 'monty 6/1/2015 19:28' prior: 0!
Abstract class for node sort orders to keep track of the order of nodes in a node set. Instances of subclasses are immutable and shared.!

XPathSortOrder class
	instanceVariableNames: 'instance'!

XPathSortOrder subclass: #XPathDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathDocumentSortOrder commentStamp: 'monty 2/10/2015 03:47' prior: 0!
A sort order for nodes in document order.!

!XPathDocumentSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:28'!
documentOrderOn: aNodeSet do: aBlock
	aNodeSet do: aBlock! !

!XPathDocumentSortOrder methodsFor: 'private' stamp: 'monty 3/30/2015 04:41'!
documentOrderReadStreamOn: aNodeSet
	^ aNodeSet readStream! !

!XPathDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 1/30/2015 17:12'!
documentOrderSort: aNodeSet
	"already in document order"! !

!XPathDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet first! !

!XPathDocumentSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:29'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	aNodeSet reverseDo: aBlock! !

!XPathDocumentSortOrder methodsFor: 'private' stamp: 'monty 5/31/2015 20:19'!
reverseDocumentOrderReadStreamOn: aNodeSet
	^ aNodeSet reverseReadStream! !

XPathDocumentSortOrder subclass: #XPathElementMetaNodeDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathElementMetaNodeDocumentSortOrder commentStamp: 'monty 4/8/2015 22:16' prior: 0!
A sort order for attribute or namespace nodes (meta nodes) in document order.!

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 04:33'!
attributeAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:37'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:37'!
descendantAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 04:34'!
descendantOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	"has no descendants"
	^ self
		selfAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:40'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:40'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 04:33'!
namespaceAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:39'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:40'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/31/2015 20:22'!
selfAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet select: aNodeTestBlock! !

XPathDocumentSortOrder subclass: #XPathLevelDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathLevelDocumentSortOrder commentStamp: 'monty 2/10/2015 03:48' prior: 0!
A sort order for nodes in document order all having the same parent, or the children of nodes having the same parent, and so on.!

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:08'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderChildAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 4/19/2015 19:25'!
descendantAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderDescendantAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 4/19/2015 19:26'!
descendantOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderDescendantOrSelfAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderFollowingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderFollowingSiblingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/31/2015 20:28'!
parentAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderParentAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderPrecedingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:08'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderPrecedingSiblingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/31/2015 21:04'!
selfAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderSelfAxisOn: aNodeSet
		select: aNodeTestBlock! !

XPathSortOrder subclass: #XPathReverseDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathReverseDocumentSortOrder commentStamp: 'monty 3/31/2015 02:16' prior: 0!
A sort order for nodes in reverse document order.!

XPathReverseDocumentSortOrder subclass: #XPathLevelReverseDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathLevelReverseDocumentSortOrder commentStamp: 'monty 2/10/2015 03:48' prior: 0!
A sort order for nodes in reverse document order all having the same parent, or the children of nodes having the same parent, and so on.!

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:08'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderChildAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 4/19/2015 19:25'!
descendantAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderDescendantAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 4/19/2015 19:26'!
descendantOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderDescendantOrSelfAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderFollowingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderFollowingSiblingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/31/2015 20:28'!
parentAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderParentAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:07'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderPrecedingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/4/2015 11:08'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderPrecedingSiblingAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/31/2015 21:04'!
selfAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		levelOrderSelfAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathReverseDocumentSortOrder methodsFor: 'private' stamp: 'monty 1/30/2015 19:18'!
documentOrderOn: aNodeSet do: aBlock
	aNodeSet reverseDo: aBlock! !

!XPathReverseDocumentSortOrder methodsFor: 'private' stamp: 'monty 3/30/2015 04:41'!
documentOrderReadStreamOn: aNodeSet
	^ aNodeSet reverseReadStream! !

!XPathReverseDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 2/3/2015 01:32'!
documentOrderSort: aNodeSet
	aNodeSet
		reverseInPlace;
		sortOrder: XPathDocumentSortOrder new! !

!XPathReverseDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet last! !

!XPathReverseDocumentSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:28'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	aNodeSet do: aBlock! !

!XPathReverseDocumentSortOrder methodsFor: 'private' stamp: 'monty 5/31/2015 20:19'!
reverseDocumentOrderReadStreamOn: aNodeSet
	^ aNodeSet readStream! !

!XPathSortOrder class methodsFor: 'instance creation' stamp: 'monty 3/7/2015 10:26'!
new
	"these classes are immutable and shared, so they are only initialized once"
	^ instance ifNil: [instance := self basicNew initialize]! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 6/2/2015 06:22'!
ancestorAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	"copy will contain the list of ancestors in document order which is then
	reversed to get a list of ancestors in reverse document order"
	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | oldSize |
		oldSize := copy size.
		self
			ancestorNodesOf: each
			select: aNodeTestBlock
			into: copy.

		"ancestors are added in reverse document order, so if more than one was
		added, reverse them in place to keep copy in document order"
		(copy size - oldSize) > 1
			ifTrue: [
				copy
					reverseInPlaceFrom: oldSize + 1
					to: copy size]].

	^ copy
		reverseInPlace;
		sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 6/2/2015 06:22'!
ancestorNodesOf: aNode select: aNodeTestBlock into: aNodeSet
	aNode ancestorNodesDo: [:each |
		(aNodeSet includes: each)
			ifTrue: [^ self].
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each]]! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 6/2/2015 06:22'!
ancestorOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	"copy will contain the list of nodes and ancestors in document order which
	is then reversed to get a list of nodes and ancestors in reverse document order"
	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | oldSize |
		oldSize := copy size.
		(copy includes: each)
			ifFalse: [
				(aNodeTestBlock value: each)
					ifTrue: [copy addLast: each].
				self
					ancestorNodesOf: each
					select: aNodeTestBlock
					into: copy].

		"nodes and ancestors are added in reverse document order, so if more
		than one was added, reverse them in place to keep copy in document order"
		(copy size - oldSize) > 1
			ifTrue: [
				copy
					reverseInPlaceFrom: oldSize + 1
					to: copy size]].

	^ copy
		reverseInPlace;
		sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/10/2015 01:04'!
attributeAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(each isElement
			and: [each hasAttributes])
			ifTrue: [
				each attributeNodesDo: [:attribute |
					(aNodeTestBlock value: attribute)
						ifTrue: [copy addLast: attribute]]]].
	^ copy sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 6/2/2015 05:38'!
childAxisOn: aNodeSet select: aNodeTestBlock
	| copy readStream |

	copy := aNodeSet copyEmpty.
	readStream := self documentOrderReadStreamOn: aNodeSet.
	[readStream atEnd]
		whileFalse: [
			self
				nodesOfNextFrom: readStream
				select: aNodeTestBlock
				into: copy].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 6/2/2015 05:29'!
descendantAxisOn: aNodeSet select: aNodeTestBlock
	| copy readStream |

	copy := aNodeSet copyEmpty.
	readStream := self documentOrderReadStreamOn: aNodeSet.
	[readStream atEnd]
		whileFalse: [
			self
				descendentNodesOfNextFrom: readStream
				select: aNodeTestBlock
				into: copy].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 6/16/2015 23:07'!
descendantOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	| copy readStream |

	copy := aNodeSet copyEmpty.
	readStream := self documentOrderReadStreamOn: aNodeSet.
	[readStream atEnd]
		whileFalse: [
			(aNodeTestBlock value: readStream peek)
				ifTrue: [copy addLast: readStream peek].
			self
				descendentNodesOfNextFrom: readStream
				select: aNodeTestBlock
				into: copy].
	^ copy sortOrder: XPathDocumentSortOrder new! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 6/16/2015 23:09'!
descendentNodesOfNextFrom: aDocumentOrderStream select: aNodeTestBlock into: aNodeSet
	aDocumentOrderStream next descendentNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet add: each].
		(aDocumentOrderStream atEnd not
			and: [aDocumentOrderStream peek = each])
			ifTrue: [aDocumentOrderStream next]]! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:28'!
documentOrderOn: aNodeSet do: aBlock
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/30/2015 04:41'!
documentOrderReadStreamOn: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'sorting' stamp: 'monty 1/26/2015 18:43'!
documentOrderSort: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrderFrom: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 5/31/2015 21:24'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	| copy readStream |

	copy := aNodeSet copyEmpty.
	readStream := self documentOrderReadStreamOn: aNodeSet.
	[readStream atEnd]
		whileFalse: [
			self
				followingNodesOfNextFrom: readStream
				select: aNodeTestBlock
				into: copy].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 6/29/2015 09:16'!
followingNodesOfNextFrom: aDocumentOrderStream select: aNodeTestBlock into: aNodeSet
	| node nextNodeAncestorOrSelf |

	node := aDocumentOrderStream next.
	"to keep document order, descendants of node with following nodes to be
	enumerated are handled first, then node's following nodes after"
	[aDocumentOrderStream atEnd or: [
		(nextNodeAncestorOrSelf :=
			aDocumentOrderStream peek lastAncestorOrSelfIn: node) isNil]]
		whileFalse: [
			self
				followingNodesOfNextFrom: aDocumentOrderStream
				select: aNodeTestBlock
				into: aNodeSet.
			nextNodeAncestorOrSelf := nil].

	node followingNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet add: each].
		(aDocumentOrderStream atEnd not
			and: [aDocumentOrderStream peek = each])
			ifTrue: [aDocumentOrderStream next]].! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 5/31/2015 20:12'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy readStream |

	copy := aNodeSet copyEmpty.
	readStream := self documentOrderReadStreamOn: aNodeSet.
	[readStream atEnd]
		whileFalse: [
			self
				followingSiblingNodesOfNextFrom: readStream
				select: aNodeTestBlock
				into: copy].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 6/30/2015 06:52'!
followingSiblingNodesOfNextFrom: aDocumentOrderStream select: aNodeTestBlock into: aNodeSet
	| node nextNodeAncestorOrSelf |

	node := aDocumentOrderStream next.
	"to keep document order, descendants of node with siblings to be
	enumerated are handled first, then node's siblings after"
	[aDocumentOrderStream atEnd or: [
		(nextNodeAncestorOrSelf :=
			aDocumentOrderStream peek lastAncestorOrSelfIn: node) isNil]]
		whileFalse: [
			self
				followingSiblingNodesOfNextFrom: aDocumentOrderStream
				select: aNodeTestBlock
				into: aNodeSet.
			nextNodeAncestorOrSelf := nil].

	(aDocumentOrderStream atEnd or: [node hasParent not])
		ifFalse: [
			nextNodeAncestorOrSelf :=
				aDocumentOrderStream peek lastAncestorOrSelfIn: node parent].
	node followingSiblingNodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet add: each].
		[nextNodeAncestorOrSelf = each]
			whileTrue: [
				nextNodeAncestorOrSelf = aDocumentOrderStream peek
					ifTrue: [aDocumentOrderStream next]
					ifFalse: [
						self
							followingSiblingNodesOfNextFrom: aDocumentOrderStream
							select: aNodeTestBlock
							into: aNodeSet].
				(aDocumentOrderStream atEnd or: [node hasParent not])
					ifTrue: [nextNodeAncestorOrSelf := nil]
					ifFalse: [
						nextNodeAncestorOrSelf :=
							aDocumentOrderStream peek lastAncestorOrSelfIn:
								node parent]]].! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/31/2015 21:06'!
levelOrderChildAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:node |
		node hasChildren
			ifTrue: [
				node nodesDo: [:each |
					(aNodeTestBlock value: each)
						ifTrue: [copy addLast: each]]]].
	"still in level order"
	^ copy sortOrder: XPathLevelDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 4/20/2015 04:51'!
levelOrderDescendantAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:node |
		node descendentNodesDo: [:each |
			(aNodeTestBlock value: each)
				ifTrue: [copy addLast: each]]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 4/19/2015 19:24'!
levelOrderDescendantOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:node |
		node allNodesDo: [:each |
			(aNodeTestBlock value: each)
				ifTrue: [copy addLast: each]]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/31/2015 08:01'!
levelOrderFollowingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:node | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [node parent = lastParentAddedFrom])
			ifFalse: [
				node followingNodesDo: [:each | 
					(aNodeTestBlock value: each)
						ifTrue: [copy addLast: each]].
				lastParentAddedFrom := node parent]].
	"not in level order anymore"
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/31/2015 21:06'!
levelOrderFollowingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:node | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [node parent = lastParentAddedFrom])
			ifFalse: [
				node followingSiblingNodesDo: [:each |
					(aNodeTestBlock value: each)
						ifTrue: [copy addLast: each]].
				lastParentAddedFrom := node parent]].
	"still in level order"
	^ copy sortOrder: XPathLevelDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/31/2015 21:05'!
levelOrderParentAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	"parent axis is a forward axis, according to spec"
	self documentOrderOn: aNodeSet do: [:each | | parent lastParentVisited |
		each hasParent
			ifTrue: [
				parent := each parent.
				(parent ~= lastParentVisited
					and: [aNodeTestBlock value: parent])
						ifTrue: [copy addLast: parent].
				lastParentVisited := parent]].
	"still in level order"
	^ copy sortOrder: XPathLevelDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/31/2015 08:02'!
levelOrderPrecedingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self reverseDocumentOrderOn: aNodeSet do: [:node | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [node parent = lastParentAddedFrom])
			ifFalse: [
				node precedingNodesDo: [:each | 
					(aNodeTestBlock value: each)
						ifTrue: [copy addLast: each]].
				lastParentAddedFrom := node parent]].
	"not in level order anymore"
	^ copy sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/31/2015 21:06'!
levelOrderPrecedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self reverseDocumentOrderOn: aNodeSet do: [:node | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [node parent = lastParentAddedFrom])
			ifFalse: [
				node precedingSiblingNodesDo: [:each | 
					(aNodeTestBlock value: each)
						ifTrue: [copy addLast: each]].
				lastParentAddedFrom := node parent]].
	"still in level order"
	^ copy sortOrder: XPathLevelReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 3/31/2015 21:03'!
levelOrderSelfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [copy addLast: each]].
	"still in level order"
	^ copy sortOrder: XPathLevelDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/10/2015 01:04'!
namespaceAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(each isElement
			and: [each hasNamespaceNodes])
			ifTrue: [
				each namespaceNodesDo: [:namespace |
					(aNodeTestBlock value: namespace)
						ifTrue: [copy addLast: namespace]]]].
	^ copy sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 6/2/2015 23:17'!
nodesOfNextFrom: aDocumentOrderStream select: aNodeTestBlock into: aNodeSet
	| node nextNodeAncestorOrSelf |

	(node := aDocumentOrderStream next) hasChildren
		ifFalse: [^ self].

	aDocumentOrderStream atEnd
		ifFalse: [
			nextNodeAncestorOrSelf :=
				aDocumentOrderStream peek lastAncestorOrSelfIn: node].

	node nodesDo: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet addLast: each].
		[each = nextNodeAncestorOrSelf]
			whileTrue: [
				self
					nodesOfNextFrom: aDocumentOrderStream
					select: aNodeTestBlock
					into: aNodeSet.
				aDocumentOrderStream atEnd
					ifTrue: [nextNodeAncestorOrSelf := nil]
					ifFalse: [
						nextNodeAncestorOrSelf :=
							aDocumentOrderStream peek lastAncestorOrSelfIn: node]]].! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 6/30/2015 06:02'!
parentAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	"parent axis is a forward axis unlike ancestor or ancestor-or-self"
	self documentOrderOn: aNodeSet do: [:each | | parent |
		(each hasParent
			and: [(copy includes: (parent := each parent)) not
				and: [aNodeTestBlock value: parent]])
			ifTrue: [copy addLast: parent]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 5/31/2015 23:59'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	| copy readStream |

	copy := aNodeSet copyEmpty.
	readStream := self reverseDocumentOrderReadStreamOn: aNodeSet.
	[readStream atEnd]
		whileFalse: [
			self
				precedingNodesOfNextFrom: readStream
				select: aNodeTestBlock
				into: copy].
	^ copy sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 6/16/2015 23:18'!
precedingNodesOfNextFrom: aReverseDocumentOrderStream select: aNodeTestBlock into: aNodeSet
	aReverseDocumentOrderStream next precedingNodesDo: [:each |
		(aReverseDocumentOrderStream atEnd not
			and: [aReverseDocumentOrderStream peek = each])
			ifTrue: [aReverseDocumentOrderStream next].
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet add: each]]! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 5/31/2015 20:17'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy readStream |

	copy := aNodeSet copyEmpty.
	readStream := self reverseDocumentOrderReadStreamOn: aNodeSet.
	[readStream atEnd]
		whileFalse: [
			self
				precedingSiblingNodesOfNextFrom: readStream
				select: aNodeTestBlock
				into: copy].
	^ copy sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 6/2/2015 23:17'!
precedingSiblingNodesOfNextFrom: aReverseDocumentOrderStream select: aNodeTestBlock into: aNodeSet
	| node nextNodeAncestorOrSelf |

	node := aReverseDocumentOrderStream next.
	(aReverseDocumentOrderStream atEnd or: [node hasParent not])
		ifFalse: [
			nextNodeAncestorOrSelf :=
				aReverseDocumentOrderStream peek lastAncestorOrSelfIn:
					node parent].

	node precedingSiblingNodesDo: [:each |
		[nextNodeAncestorOrSelf = each]
			whileTrue: [
				nextNodeAncestorOrSelf = aReverseDocumentOrderStream peek
					ifTrue: [aReverseDocumentOrderStream next]
					ifFalse: [
						self
							precedingSiblingNodesOfNextFrom: aReverseDocumentOrderStream
							select: aNodeTestBlock
							into: aNodeSet].
				(aReverseDocumentOrderStream atEnd or: [node hasParent not])
					ifTrue: [nextNodeAncestorOrSelf := nil]
					ifFalse: [
						nextNodeAncestorOrSelf :=
							aReverseDocumentOrderStream peek lastAncestorOrSelfIn:
								node parent]].
		(aNodeTestBlock value: each)
			ifTrue: [aNodeSet add: each]].! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:27'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 5/31/2015 20:18'!
reverseDocumentOrderReadStreamOn: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/31/2015 08:52'!
selfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [copy addLast: each]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

XPathSortOrder subclass: #XPathUnknownSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathUnknownSortOrder commentStamp: 'monty 2/10/2015 03:49' prior: 0!
A sort order for unsorted nodes or nodes in an unknown sort order.!

!XPathUnknownSortOrder methodsFor: 'private' stamp: 'monty 1/30/2015 19:19'!
documentOrderOn: aNodeSet do: aBlock
	aNodeSet sorted do: aBlock! !

!XPathUnknownSortOrder methodsFor: 'private' stamp: 'monty 3/30/2015 04:41'!
documentOrderReadStreamOn: aNodeSet
	^ aNodeSet sorted readStream! !

!XPathUnknownSortOrder methodsFor: 'sorting' stamp: 'monty 6/9/2015 01:58'!
documentOrderSort: aNodeSet
	(XPathNodeSetSorter on: aNodeSet) sort! !

!XPathUnknownSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet sorted first! !

!XPathUnknownSortOrder methodsFor: 'private' stamp: 'monty 6/4/2015 20:25'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	aNodeSet sorted reverseDo: aBlock! !

!XPathUnknownSortOrder methodsFor: 'private' stamp: 'monty 6/4/2015 20:22'!
reverseDocumentOrderReadStreamOn: aNodeSet
	^ aNodeSet sorted reverseReadStream! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:17'!
/ aNodeTestStringOrBlock
	"child axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self hasChildren
		ifTrue: [
			self nodesDo: [:each |
				(nodeTestBlock value: each)
					ifTrue: [nodeSet addLast: each]]].
	^ nodeSet sortOrder: XPathLevelDocumentSortOrder new.! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:17'!
// aNodeTestStringOrBlock
	"descendant axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self descendentNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 6/30/2015 05:20'!
//~ aNodeTestStringOrBlock
	"descendant-or-self axis"
	| nodeSet nodeTestBlock |

	nodeSet := self nodeSetClass new.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self allNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XMLNodeWithElements methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	"spec says the string-value of documents and elements is all text
	descendants concatenated, so contentString can't be used because it
	inserts spaces"
	^ self rawContentString! !

XPathAxis initialize!

XPathNodeTestParser initialize!

XPathContext initialize!

XPathExpressionParser initialize!

XPath initialize!
